//-----------------------------------------------------------------------------
// Copyright (c) 2007 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
//-----------------------------------------------------------------------------
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor: Xilinx
// \   \   \/    Version: 
//  \   \        Filename: mpmc_core.v
//  /   /        Date Last Modified:  Nov 7 2007
// /___/   /\    Date Created: 
// \   \  /  \
//  \___\/\___\
// 
//-----------------------------------------------------------------------------
// History:
//   Jul 18 2008: Merged MIG 2.3 modifications into this file.
// 
//-----------------------------------------------------------------------------

`timescale 1ns/1ns
`default_nettype none

module mpmc_core
#(
  parameter C_FAMILY                  = "virtex4",
  parameter C_MEM_TYPE                = "INVALID",
  parameter C_SKIP_INIT_DELAY         = 1'b0,
  parameter C_USE_STATIC_PHY              = 1'b0,
  parameter C_STATIC_PHY_RDDATA_CLK_SEL   = 1'b0,
  parameter C_STATIC_PHY_RDDATA_SWAP_RISE = 1'b0,
  parameter C_STATIC_PHY_RDEN_DELAY       = 4'h0,
  parameter C_INCLUDE_ECC_SUPPORT       = 0,
  parameter C_INCLUDE_ECC_TEST          = 1,
  parameter C_ECC_DEFAULT_ON            = 1,
  parameter C_ECC_SEC_THRESHOLD         = 1,
  parameter C_ECC_DEC_THRESHOLD         = 1,
  parameter C_ECC_PEC_THRESHOLD         = 1,
  parameter C_IS_DDR                    = 1'b1,     // Allowed Values: 0,1 
  parameter C_SPECIAL_BOARD             = 0,
  parameter C_NUM_PORTS                 = 8,        // Allowed Values: 1-8
  parameter C_MEM_DQS_IO_COL            = 18'b0,
  parameter C_MEM_DQ_IO_MS              = 72'b0,
  parameter C_MEM_DQS_MATCHED           = 1'b0,     // Allowed Values: 0,1
  parameter C_MEM_CAS_LATENCY0          = 2,        // Allowed Values: integer
  parameter C_MEM_CAS_LATENCY1          = 2,        // Allowed Values: integer
  parameter C_MEM_BURST_LENGTH          = 8,        // Allowed Values: 2,4,8
  parameter C_MEM_ADDITIVE_LATENCY      = 0,
  parameter C_MEM_ODT_TYPE              = 0,
  parameter C_MEM_REDUCED_DRV           = 0,
  parameter C_MEM_REG_DIMM              = 0,
  parameter C_MEM_CLK_PERIOD            = 5000,
  parameter C_MEM_DDR2_ENABLE           = 1,
  parameter C_MEM_DQSN_ENABLE           = 1,
  parameter C_MEM_DQS_GATE_EN           = 0,
  parameter C_MEM_IDEL_HIGH_PERF        = "FALSE",
  parameter C_MEM_CLK_WIDTH             = 1,        // Allowed Values: integer
  parameter C_MEM_ODT_WIDTH             = 1,        // Allowed Values: integer
  parameter C_MEM_CE_WIDTH              = 1,        // Allowed Values: integer
  parameter C_MEM_CS_N_WIDTH            = 1,        // Allowed Values: integer
  parameter C_MEM_ADDR_WIDTH            = 13,       // Allowed Values: 12-16
  parameter C_MEM_BANKADDR_WIDTH        = 2,        // Allowed Values: 2,3
  parameter C_MEM_DATA_WIDTH            = 32,       // Allowed Values: 32,64
  parameter C_MEM_DATA_WIDTH_INT        = 32,       // Allowed Values: 32,64
  parameter C_ECC_DATA_WIDTH            = 0,
  parameter C_ECC_DATA_WIDTH_INT        = 0,
  parameter C_ECC_DM_WIDTH              = 0,
  parameter C_ECC_DM_WIDTH_INT          = 0,
  parameter C_ECC_DQS_WIDTH             = 0,
  parameter C_ECC_DQS_WIDTH_INT         = 0,
  parameter C_MEM_DM_WIDTH              = 4,
  parameter C_MEM_DM_WIDTH_INT          = 4,
  parameter C_MEM_DQS_WIDTH             = 4,
  parameter C_MEM_DQS_WIDTH_INT         = 4,
  parameter C_MEM_BITS_DATA_PER_DQS     = 8,        // Allowed Values: 4,8,16,32,64
  parameter C_MEM_NUM_DIMMS             = 1,        // Allowed Values: 1,2
  parameter C_MEM_NUM_RANKS             = 1,        // Allowed Values: 1,2
  parameter C_MEM_SUPPORTED_TOTAL_OFFSETS = 32'h08000000,
  parameter C_MEM_SUPPORTED_DIMM_OFFSETS  = 32'h08000000,
  parameter C_MEM_SUPPORTED_RANK_OFFSETS  = 32'h08000000,
  parameter C_MEM_SUPPORTED_BANK_OFFSETS  = 32'h02000000,
  parameter C_MEM_SUPPORTED_ROW_OFFSETS   = 32'h00001000,
  parameter C_MEM_SUPPORTED_COL_OFFSETS   = 32'h00000004,
  parameter C_WR_TRAINING_PORT          = 3'b001,
  parameter C_PIX_ADDR_WIDTH_MAX        = 32,
  parameter C_PIX_DATA_WIDTH_MAX        = 64,
  parameter C_PI_DATA_WIDTH             = 8'hFF,
  parameter C_PIX_BE_WIDTH_MAX          = 8,
  parameter C_PIX_RDWDADDR_WIDTH_MAX    = 4,
  parameter C_WR_DATAPATH_TML_PIPELINE  = 0,    // Allowed Values: 0, 1
  parameter C_RD_DATAPATH_TML_MAX_FANOUT  = 0,
  parameter C_AP_PIPELINE1              = 1,        // Allowed Values: 0,1
  parameter C_AP_PIPELINE2              = 1,        // Allowed Values: 0,1
  parameter C_NUM_CTRL_SIGNALS          = 36,       // Allowed Values: 1-36
  parameter C_PIPELINE_ADDRACK          = 8'h00,    // Allowed Values: 8'h00-8'hFF, each
                                                  // bit corresponds to an individual 
                                                  // port.
  parameter C_CP_PIPELINE               = 1,        // Allowed Values: 0-1
  parameter C_ARB_PIPELINE              = 0,        // Allowed Values: 0-1
  parameter C_MAX_REQ_ALLOWED           = 1,        // Allowed Values: Any integer
                                        
  parameter C_REQ_PENDING_CNTR_WIDTH    = 2,        // Allowed Values: Such that 
                                                  // counter does not overflow 
                                                  // when max pending 
                                                  // instructions are 
                                                  // acknowledged

  parameter C_REFRESH_CNT_MAX           = 1560,     // Allowed Values: Any interger
  parameter C_REFRESH_CNT_WIDTH         = 11,       // Allowed Values: Large enough to support C_REFRESH_CNT_MAX
  parameter C_ECC_NUM_REG               = 10,
  parameter C_STATIC_PHY_NUM_REG        = 10,

  parameter C_WORD_WRITE_SEQ            = 0,
  parameter C_WORD_READ_SEQ             = 0,
  parameter C_DOUBLEWORD_WRITE_SEQ      = 0,
  parameter C_DOUBLEWORD_READ_SEQ       = 0,
  parameter C_CL4_WRITE_SEQ             = 0,
  parameter C_CL4_READ_SEQ              = 0,
  parameter C_CL8_WRITE_SEQ             = 0,
  parameter C_CL8_READ_SEQ              = 0,
  parameter C_B16_WRITE_SEQ             = 0,
  parameter C_B16_READ_SEQ              = 0,
  parameter C_B32_WRITE_SEQ             = 0,
  parameter C_B32_READ_SEQ              = 0,
  parameter C_B64_WRITE_SEQ             = 0,
  parameter C_B64_READ_SEQ              = 0,
  parameter C_NOP_SEQ                   = 0,
  parameter C_REFH_SEQ                  = 0,
  parameter C_TWR                       = 0,
  parameter C_CTRL_AP_COL_DELAY         = 0,
  parameter C_CTRL_AP_PI_ADDR_CE_DELAY        = 0,
  parameter C_CTRL_AP_PORT_SELECT_DELAY       = 0,
  parameter C_CTRL_AP_PIPELINE1_CE_DELAY      = 0,
  parameter C_CTRL_DP_LOAD_RDWDADDR_DELAY     = 0,
  parameter C_CTRL_DP_RDFIFO_WHICHPORT_DELAY  = 0,
  parameter C_CTRL_DP_SIZE_DELAY              = 0,
  parameter C_CTRL_DP_WRFIFO_WHICHPORT_DELAY  = 0,
  parameter C_CTRL_PHYIF_DUMMYREADSTART_DELAY = 0,
  parameter C_CTRL_Q0_DELAY           = 4'h0,
  parameter C_CTRL_Q1_DELAY           = 4'h0,
  parameter C_CTRL_Q2_DELAY           = 4'h0,
  parameter C_CTRL_Q3_DELAY           = 4'h0,
  parameter C_CTRL_Q4_DELAY           = 4'h0,
  parameter C_CTRL_Q5_DELAY           = 4'h0,
  parameter C_CTRL_Q6_DELAY           = 4'h0,
  parameter C_CTRL_Q7_DELAY           = 4'h0,
  parameter C_CTRL_Q8_DELAY           = 4'h0,
  parameter C_CTRL_Q9_DELAY           = 4'h0,
  parameter C_CTRL_Q10_DELAY          = 4'h0,
  parameter C_CTRL_Q11_DELAY          = 4'h0,
  parameter C_CTRL_Q12_DELAY          = 4'h0,
  parameter C_CTRL_Q13_DELAY          = 4'h0,
  parameter C_CTRL_Q14_DELAY          = 4'h0,
  parameter C_CTRL_Q15_DELAY          = 4'h0,
  parameter C_CTRL_Q16_DELAY          = 4'h0,
  parameter C_CTRL_Q17_DELAY          = 4'h0,
  parameter C_CTRL_Q18_DELAY          = 4'h0,
  parameter C_CTRL_Q19_DELAY          = 4'h0,
  parameter C_CTRL_Q20_DELAY          = 4'h0,
  parameter C_CTRL_Q21_DELAY          = 4'h0,
  parameter C_CTRL_Q22_DELAY          = 4'h0,
  parameter C_CTRL_Q23_DELAY          = 4'h0,
  parameter C_CTRL_Q24_DELAY          = 4'h0,
  parameter C_CTRL_Q25_DELAY          = 4'h0,
  parameter C_CTRL_Q26_DELAY          = 4'h0,
  parameter C_CTRL_Q27_DELAY          = 4'h0,
  parameter C_CTRL_Q28_DELAY          = 4'h0,
  parameter C_CTRL_Q29_DELAY          = 4'h0,
  parameter C_CTRL_Q30_DELAY          = 4'h0,
  parameter C_CTRL_Q31_DELAY          = 4'h0,
  parameter C_CTRL_Q32_DELAY          = 4'h0,
  parameter C_CTRL_Q33_DELAY          = 4'h0,
  parameter C_CTRL_Q34_DELAY          = 4'h0,
  parameter C_CTRL_Q35_DELAY          = 4'h0,
  parameter C_ARB0_ALGO               = "ROUND_ROBIN",
  parameter C_BASEADDR_ARB0           = 9'h0,
  parameter C_HIGHADDR_ARB0           = 9'h0,
  parameter C_BASEADDR_ARB1           = 9'h0,
  parameter C_HIGHADDR_ARB1           = 9'h0,
  parameter C_BASEADDR_ARB2           = 9'h0,
  parameter C_HIGHADDR_ARB2           = 9'h0,
  parameter C_BASEADDR_ARB3           = 9'h0,
  parameter C_HIGHADDR_ARB3           = 9'h0,
  parameter C_BASEADDR_ARB4           = 9'h0,
  parameter C_HIGHADDR_ARB4           = 9'h0,
  parameter C_BASEADDR_ARB5           = 9'h0,
  parameter C_HIGHADDR_ARB5           = 9'h0,
  parameter C_BASEADDR_ARB6           = 9'h0,
  parameter C_HIGHADDR_ARB6           = 9'h0,
  parameter C_BASEADDR_ARB7           = 9'h0,
  parameter C_HIGHADDR_ARB7           = 9'h0,
  parameter C_BASEADDR_ARB8           = 9'h0,
  parameter C_HIGHADDR_ARB8           = 9'h0,
  parameter C_BASEADDR_ARB9           = 9'h0,
  parameter C_HIGHADDR_ARB9           = 9'h0,
  parameter C_BASEADDR_ARB10          = 9'h0,
  parameter C_HIGHADDR_ARB10          = 9'h0,
  parameter C_BASEADDR_ARB11          = 9'h0,
  parameter C_HIGHADDR_ARB11          = 9'h0,
  parameter C_BASEADDR_ARB12          = 9'h0,
  parameter C_HIGHADDR_ARB12          = 9'h0,
  parameter C_BASEADDR_ARB13          = 9'h0,
  parameter C_HIGHADDR_ARB13          = 9'h0,
  parameter C_BASEADDR_ARB14          = 9'h0,
  parameter C_HIGHADDR_ARB14          = 9'h0,
  parameter C_BASEADDR_ARB15          = 9'h0,
  parameter C_HIGHADDR_ARB15          = 9'h0,
  parameter C_ARB_BRAM_SRVAL_A        = 36'h0,
  parameter C_ARB_BRAM_SRVAL_B        = 36'h0,
  parameter C_ARB_BRAM_INIT_00        = 256'h0,
  parameter C_ARB_BRAM_INIT_01        = 256'h0,
  parameter C_ARB_BRAM_INIT_02        = 256'h0,
  parameter C_ARB_BRAM_INIT_03        = 256'h0,
  parameter C_ARB_BRAM_INIT_04        = 256'h0,
  parameter C_ARB_BRAM_INIT_05        = 256'h0,
  parameter C_ARB_BRAM_INIT_06        = 256'h0,
  parameter C_ARB_BRAM_INIT_07        = 256'h0,
  parameter C_ARB_BRAM_INIT_08        = 256'h0,
  parameter C_ARB_BRAM_INIT_09        = 256'h0,
  parameter C_ARB_BRAM_INIT_0A        = 256'h0,
  parameter C_ARB_BRAM_INIT_0B        = 256'h0,
  parameter C_ARB_BRAM_INIT_0C        = 256'h0,
  parameter C_ARB_BRAM_INIT_0D        = 256'h0,
  parameter C_ARB_BRAM_INIT_0E        = 256'h0,
  parameter C_ARB_BRAM_INIT_0F        = 256'h0,
  parameter C_ARB_BRAM_INIT_10        = 256'h0,
  parameter C_ARB_BRAM_INIT_11        = 256'h0,
  parameter C_ARB_BRAM_INIT_12        = 256'h0,
  parameter C_ARB_BRAM_INIT_13        = 256'h0,
  parameter C_ARB_BRAM_INIT_14        = 256'h0,
  parameter C_ARB_BRAM_INIT_15        = 256'h0,
  parameter C_ARB_BRAM_INIT_16        = 256'h0,
  parameter C_ARB_BRAM_INIT_17        = 256'h0,
  parameter C_ARB_BRAM_INIT_18        = 256'h0,
  parameter C_ARB_BRAM_INIT_19        = 256'h0,
  parameter C_ARB_BRAM_INIT_1A        = 256'h0,
  parameter C_ARB_BRAM_INIT_1B        = 256'h0,
  parameter C_ARB_BRAM_INIT_1C        = 256'h0,
  parameter C_ARB_BRAM_INIT_1D        = 256'h0,
  parameter C_ARB_BRAM_INIT_1E        = 256'h0,
  parameter C_ARB_BRAM_INIT_1F        = 256'h0,
  parameter C_ARB_BRAM_INIT_20        = 256'h0,
  parameter C_ARB_BRAM_INIT_21        = 256'h0,
  parameter C_ARB_BRAM_INIT_22        = 256'h0,
  parameter C_ARB_BRAM_INIT_23        = 256'h0,
  parameter C_ARB_BRAM_INIT_24        = 256'h0,
  parameter C_ARB_BRAM_INIT_25        = 256'h0,
  parameter C_ARB_BRAM_INIT_26        = 256'h0,
  parameter C_ARB_BRAM_INIT_27        = 256'h0,
  parameter C_ARB_BRAM_INIT_28        = 256'h0,
  parameter C_ARB_BRAM_INIT_29        = 256'h0,
  parameter C_ARB_BRAM_INIT_2A        = 256'h0,
  parameter C_ARB_BRAM_INIT_2B        = 256'h0,
  parameter C_ARB_BRAM_INIT_2C        = 256'h0,
  parameter C_ARB_BRAM_INIT_2D        = 256'h0,
  parameter C_ARB_BRAM_INIT_2E        = 256'h0,
  parameter C_ARB_BRAM_INIT_2F        = 256'h0,
  parameter C_ARB_BRAM_INIT_30        = 256'h0,
  parameter C_ARB_BRAM_INIT_31        = 256'h0,
  parameter C_ARB_BRAM_INIT_32        = 256'h0,
  parameter C_ARB_BRAM_INIT_33        = 256'h0,
  parameter C_ARB_BRAM_INIT_34        = 256'h0,
  parameter C_ARB_BRAM_INIT_35        = 256'h0,
  parameter C_ARB_BRAM_INIT_36        = 256'h0,
  parameter C_ARB_BRAM_INIT_37        = 256'h0,
  parameter C_ARB_BRAM_INIT_38        = 256'h0,
  parameter C_ARB_BRAM_INIT_39        = 256'h0,
  parameter C_ARB_BRAM_INIT_3A        = 256'h0,
  parameter C_ARB_BRAM_INIT_3B        = 256'h0,
  parameter C_ARB_BRAM_INIT_3C        = 256'h0,
  parameter C_ARB_BRAM_INIT_3D        = 256'h0,
  parameter C_ARB_BRAM_INIT_3E        = 256'h0,
  parameter C_ARB_BRAM_INIT_3F        = 256'h0,
  parameter C_ARB_BRAM_INITP_00       = 256'h0,
  parameter C_ARB_BRAM_INITP_01       = 256'h0,
  parameter C_ARB_BRAM_INITP_02       = 256'h0,
  parameter C_ARB_BRAM_INITP_03       = 256'h0,
  parameter C_ARB_BRAM_INITP_04       = 256'h0,
  parameter C_ARB_BRAM_INITP_05       = 256'h0,
  parameter C_ARB_BRAM_INITP_06       = 256'h0,
  parameter C_ARB_BRAM_INITP_07       = 256'h0,
  parameter C_USE_FIXED_BASEADDR_CTRL = 0,
  parameter C_B16_REPEAT_CNT          = 0,
  parameter C_B32_REPEAT_CNT          = 0,
  parameter C_B64_REPEAT_CNT          = 0,
  parameter C_BASEADDR_CTRL0          = 9'h0,
  parameter C_HIGHADDR_CTRL0          = 9'h0,
  parameter C_BASEADDR_CTRL1          = 9'h0,
  parameter C_HIGHADDR_CTRL1          = 9'h0,
  parameter C_BASEADDR_CTRL2          = 9'h0,
  parameter C_HIGHADDR_CTRL2          = 9'h0,
  parameter C_BASEADDR_CTRL3          = 9'h0,
  parameter C_HIGHADDR_CTRL3          = 9'h0,
  parameter C_BASEADDR_CTRL4          = 9'h0,
  parameter C_HIGHADDR_CTRL4          = 9'h0,
  parameter C_BASEADDR_CTRL5          = 9'h0,
  parameter C_HIGHADDR_CTRL5          = 9'h0,
  parameter C_BASEADDR_CTRL6          = 9'h0,
  parameter C_HIGHADDR_CTRL6          = 9'h0,
  parameter C_BASEADDR_CTRL7          = 9'h0,
  parameter C_HIGHADDR_CTRL7          = 9'h0,
  parameter C_BASEADDR_CTRL8          = 9'h0,
  parameter C_HIGHADDR_CTRL8          = 9'h0,
  parameter C_BASEADDR_CTRL9          = 9'h0,
  parameter C_HIGHADDR_CTRL9          = 9'h0,
  parameter C_BASEADDR_CTRL10         = 9'h0,
  parameter C_HIGHADDR_CTRL10         = 9'h0,
  parameter C_BASEADDR_CTRL11         = 9'h0,
  parameter C_HIGHADDR_CTRL11         = 9'h0,
  parameter C_BASEADDR_CTRL12         = 9'h0,
  parameter C_HIGHADDR_CTRL12         = 9'h0,
  parameter C_BASEADDR_CTRL13         = 9'h0,
  parameter C_HIGHADDR_CTRL13         = 9'h0,
  parameter C_BASEADDR_CTRL14         = 9'h0,
  parameter C_HIGHADDR_CTRL14         = 9'h0,
  parameter C_BASEADDR_CTRL15         = 9'h0,
  parameter C_HIGHADDR_CTRL15         = 9'h0,
  // Ctrl_path_table params
  parameter C_CTRL_BRAM_SRVAL         = 36'h0,
  parameter C_CTRL_BRAM_INIT_00       = 256'h0,
  parameter C_CTRL_BRAM_INIT_01       = 256'h0,
  parameter C_CTRL_BRAM_INIT_02       = 256'h0,
  parameter C_CTRL_BRAM_INIT_03       = 256'h0,
  parameter C_CTRL_BRAM_INIT_04       = 256'h0,
  parameter C_CTRL_BRAM_INIT_05       = 256'h0,
  parameter C_CTRL_BRAM_INIT_06       = 256'h0,
  parameter C_CTRL_BRAM_INIT_07       = 256'h0,
  parameter C_CTRL_BRAM_INIT_08       = 256'h0,
  parameter C_CTRL_BRAM_INIT_09       = 256'h0,
  parameter C_CTRL_BRAM_INIT_0A       = 256'h0,
  parameter C_CTRL_BRAM_INIT_0B       = 256'h0,
  parameter C_CTRL_BRAM_INIT_0C       = 256'h0,
  parameter C_CTRL_BRAM_INIT_0D       = 256'h0,
  parameter C_CTRL_BRAM_INIT_0E       = 256'h0,
  parameter C_CTRL_BRAM_INIT_0F       = 256'h0,
  parameter C_CTRL_BRAM_INIT_10       = 256'h0,
  parameter C_CTRL_BRAM_INIT_11       = 256'h0,
  parameter C_CTRL_BRAM_INIT_12       = 256'h0,
  parameter C_CTRL_BRAM_INIT_13       = 256'h0,
  parameter C_CTRL_BRAM_INIT_14       = 256'h0,
  parameter C_CTRL_BRAM_INIT_15       = 256'h0,
  parameter C_CTRL_BRAM_INIT_16       = 256'h0,
  parameter C_CTRL_BRAM_INIT_17       = 256'h0,
  parameter C_CTRL_BRAM_INIT_18       = 256'h0,
  parameter C_CTRL_BRAM_INIT_19       = 256'h0,
  parameter C_CTRL_BRAM_INIT_1A       = 256'h0,
  parameter C_CTRL_BRAM_INIT_1B       = 256'h0,
  parameter C_CTRL_BRAM_INIT_1C       = 256'h0,
  parameter C_CTRL_BRAM_INIT_1D       = 256'h0,
  parameter C_CTRL_BRAM_INIT_1E       = 256'h0,
  parameter C_CTRL_BRAM_INIT_1F       = 256'h0,
  parameter C_CTRL_BRAM_INIT_20       = 256'h0,
  parameter C_CTRL_BRAM_INIT_21       = 256'h0,
  parameter C_CTRL_BRAM_INIT_22       = 256'h0,
  parameter C_CTRL_BRAM_INIT_23       = 256'h0,
  parameter C_CTRL_BRAM_INIT_24       = 256'h0,
  parameter C_CTRL_BRAM_INIT_25       = 256'h0,
  parameter C_CTRL_BRAM_INIT_26       = 256'h0,
  parameter C_CTRL_BRAM_INIT_27       = 256'h0,
  parameter C_CTRL_BRAM_INIT_28       = 256'h0,
  parameter C_CTRL_BRAM_INIT_29       = 256'h0,
  parameter C_CTRL_BRAM_INIT_2A       = 256'h0,
  parameter C_CTRL_BRAM_INIT_2B       = 256'h0,
  parameter C_CTRL_BRAM_INIT_2C       = 256'h0,
  parameter C_CTRL_BRAM_INIT_2D       = 256'h0,
  parameter C_CTRL_BRAM_INIT_2E       = 256'h0,
  parameter C_CTRL_BRAM_INIT_2F       = 256'h0,
  parameter C_CTRL_BRAM_INIT_30       = 256'h0,
  parameter C_CTRL_BRAM_INIT_31       = 256'h0,
  parameter C_CTRL_BRAM_INIT_32       = 256'h0,
  parameter C_CTRL_BRAM_INIT_33       = 256'h0,
  parameter C_CTRL_BRAM_INIT_34       = 256'h0,
  parameter C_CTRL_BRAM_INIT_35       = 256'h0,
  parameter C_CTRL_BRAM_INIT_36       = 256'h0,
  parameter C_CTRL_BRAM_INIT_37       = 256'h0,
  parameter C_CTRL_BRAM_INIT_38       = 256'h0,
  parameter C_CTRL_BRAM_INIT_39       = 256'h0,
  parameter C_CTRL_BRAM_INIT_3A       = 256'h0,
  parameter C_CTRL_BRAM_INIT_3B       = 256'h0,
  parameter C_CTRL_BRAM_INIT_3C       = 256'h0,
  parameter C_CTRL_BRAM_INIT_3D       = 256'h0,
  parameter C_CTRL_BRAM_INIT_3E       = 256'h0,
  parameter C_CTRL_BRAM_INIT_3F       = 256'h0,
  parameter C_CTRL_BRAM_INITP_00      = 256'h0,
  parameter C_CTRL_BRAM_INITP_01      = 256'h0,
  parameter C_CTRL_BRAM_INITP_02      = 256'h0,
  parameter C_CTRL_BRAM_INITP_03      = 256'h0,
  parameter C_CTRL_BRAM_INITP_04      = 256'h0,
  parameter C_CTRL_BRAM_INITP_05      = 256'h0,
  parameter C_CTRL_BRAM_INITP_06      = 256'h0,
  parameter C_CTRL_BRAM_INITP_07      = 256'h0,
  parameter C_SKIP_1_VALUE            = 9'h0,
  parameter C_SKIP_2_VALUE            = 9'h0,
  parameter C_SKIP_3_VALUE            = 9'h0,
  parameter C_SKIP_4_VALUE            = 9'h0,
  parameter C_SKIP_5_VALUE            = 9'h0,
  parameter C_SKIP_6_VALUE            = 9'h0,
  parameter C_SKIP_7_VALUE            = 9'h0,

  // Port Parameters
  parameter C_PI0_ADDR_WIDTH          = 32,      // Allowed Values: 32
  parameter C_PI0_DATA_WIDTH          = 64,      // Allowed Values: 64
  parameter C_PI0_BE_WIDTH            = C_PI0_DATA_WIDTH/8,
  parameter C_PI0_RDWDADDR_WIDTH      = 4,       // Allowed Values: 4,5
  parameter C_PI0_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI0_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI0_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI0_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI0_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI0_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM

  parameter C_PI1_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI1_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI1_BE_WIDTH          = C_PI1_DATA_WIDTH/8,
  parameter C_PI1_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI2_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI2_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI2_BE_WIDTH          = C_PI2_DATA_WIDTH/8,
  parameter C_PI2_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI3_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI3_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI3_BE_WIDTH          = C_PI3_DATA_WIDTH/8,
  parameter C_PI3_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI4_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI4_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI4_BE_WIDTH          = C_PI4_DATA_WIDTH/8,
  parameter C_PI4_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI5_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI5_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI5_BE_WIDTH          = C_PI5_DATA_WIDTH/8,
  parameter C_PI5_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI6_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI6_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI6_BE_WIDTH          = C_PI6_DATA_WIDTH/8,
  parameter C_PI6_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI7_ADDR_WIDTH        = 32,      // Allowed Values: 32
  parameter C_PI7_DATA_WIDTH        = 64,      // Allowed Values: 64
  parameter C_PI7_BE_WIDTH          = C_PI7_DATA_WIDTH/8,
  parameter C_PI7_RDWDADDR_WIDTH    = 4,       // Allowed Values: 4,5
  parameter C_PI1_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI1_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI1_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI1_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI1_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI1_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI2_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI2_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI2_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI2_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI2_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI2_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI3_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI3_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI3_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI3_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI3_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI3_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI4_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI4_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI4_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI4_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI4_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI4_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI5_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI5_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI5_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI5_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI5_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI5_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI6_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI6_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI6_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI6_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI6_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI6_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI7_RD_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI7_RD_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI7_RD_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter C_PI7_WR_FIFO_APP_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI7_WR_FIFO_MEM_PIPELINE = 0,    // Allowed Values: 0,1
  parameter C_PI7_WR_FIFO_TYPE = "DISABLED",   // Allowed Values: DISABLED,SRL,BRAM
  parameter integer C_TBY4TAPVALUE     = (C_MEM_CLK_PERIOD/4)/78.125
)
(
  // System Signals
  input  wire                                          Clk0,
  input  wire                                          Clk0_DIV2,
  input  wire                                          Clk90,
  input  wire                                          Clk_200MHz,
  input  wire                                          Clk_Mem,
  output reg                                           InitDone = 1'b0,
  input  wire [C_NUM_PORTS*2+4:0]                      Rst,
  input  wire                                          Rst90,
  output wire                                          ECC_Intr,
  output wire                                          DCM_PSEN,
  output wire                                          DCM_PSINCDEC,
  input  wire                                          DCM_PSDONE,
  
  // Memory Interface Signals
  output wire [C_MEM_CLK_WIDTH-1:0]                    Mem_Clk_O,
  output wire [C_MEM_CLK_WIDTH-1:0]                    Mem_Clk_n_O,
  output wire [C_MEM_CE_WIDTH-1:0]                     Mem_CE_O,
  output wire [C_MEM_CS_N_WIDTH-1:0]                   Mem_CS_n_O,
  output wire [C_MEM_ODT_WIDTH-1:0]                    Mem_ODT_O,
  output wire                                          Mem_RAS_n_O,
  output wire                                          Mem_CAS_n_O,
  output wire                                          Mem_WE_n_O,
  output wire [C_MEM_BANKADDR_WIDTH-1:0]               Mem_BankAddr_O,
  output wire [C_MEM_ADDR_WIDTH-1:0]                   Mem_Addr_O,
  
  output wire [C_MEM_CE_WIDTH-1:0]                     Mem_CE_O_2,
  output wire [C_MEM_CS_N_WIDTH-1:0]                   Mem_CS_n_O_2,
  output wire [C_MEM_ODT_WIDTH-1:0]                    Mem_ODT_O_2,
  output wire                                          Mem_RAS_n_O_2,
  output wire                                          Mem_CAS_n_O_2,
  output wire                                          Mem_WE_n_O_2,
  output wire [C_MEM_BANKADDR_WIDTH-1:0]               Mem_BankAddr_O_2,
  output wire [C_MEM_ADDR_WIDTH-1:0]                   Mem_Addr_O_2,
  
  output wire [C_ECC_DM_WIDTH+C_MEM_DM_WIDTH-1:0]      Mem_DM_O,
  output wire                                          Mem_DQS_Div_O,
  input  wire                                          Mem_DQS_Div_I,
  inout  wire [C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH-1:0]  DDR2_DQ,
  inout  wire [C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH-1:0]    DDR2_DQS,
  inout  wire [C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH-1:0]    DDR2_DQS_n,
  inout  wire [C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH-1:0]  DDR_DQ,
  inout  wire [C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH-1:0]    DDR_DQS,
  inout  wire [C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH-1:0]  SDRAM_DQ,
  
  // Serial Presence Detect (SPD) IIC Signals to DIMM
  output wire                                          SPD_SCL,
  output wire                                          SPD_WP,
  output wire [2:0]                                    SPD_SA,
  input  wire                                          SPD_SDA_I,
  output wire                                          SPD_SDA_O,
  output wire                                          SPD_SDA_T,
  // MPMC_CTRL signals
  input  wire  [C_ECC_NUM_REG-1:0]                     ECC_Reg_CE,
  input  wire  [31:0]                                  ECC_Reg_In,
  output wire [C_ECC_NUM_REG*32-1:0]                   ECC_Reg_Out,
  input  wire  [C_STATIC_PHY_NUM_REG-1:0]              Static_Phy_Reg_CE,
  input  wire  [31:0]                                  Static_Phy_Reg_In,
  output wire [C_STATIC_PHY_NUM_REG*32-1:0]            Static_Phy_Reg_Out,
  // Port 0
  // Port Interface Status Signals
  output wire [C_NUM_PORTS-1:0]                        PI_InitDone,
  // Port Interface Request/Acknowledge/Address Signals
  input  wire [C_NUM_PORTS*C_PIX_ADDR_WIDTH_MAX-1:0]   PI_Addr,
  input  wire [C_NUM_PORTS-1:0]                        PI_AddrReq,
  output wire [C_NUM_PORTS-1:0]                        PI_AddrAck,
  input  wire [C_NUM_PORTS-1:0]                        PI_RNW,
  input  wire [C_NUM_PORTS*4-1:0]                      PI_Size,
  input  wire [C_NUM_PORTS-1:0]                        PI_RdModWr,
  // Port Interface Data Signals
  input  wire [C_NUM_PORTS*C_PIX_DATA_WIDTH_MAX-1:0]   PI_WrFIFO_Data,
  input  wire [C_NUM_PORTS*C_PIX_BE_WIDTH_MAX-1:0]     PI_WrFIFO_BE,
  input  wire [C_NUM_PORTS-1:0]                        PI_WrFIFO_Push,
  output wire [C_NUM_PORTS*C_PIX_DATA_WIDTH_MAX-1:0]   PI_RdFIFO_Data,
  input  wire [C_NUM_PORTS-1:0]                        PI_RdFIFO_Pop,
  output wire [C_NUM_PORTS*C_PIX_RDWDADDR_WIDTH_MAX-1:0]   PI_RdFIFO_RdWdAddr,
  // Port Interface FIFO control/status
  output wire [C_NUM_PORTS-1:0]                        PI_WrFIFO_Empty,
  output wire [C_NUM_PORTS-1:0]                        PI_WrFIFO_AlmostFull,
  input  wire [C_NUM_PORTS-1:0]                        PI_WrFIFO_Flush,
  output wire [C_NUM_PORTS-1:0]                        PI_RdFIFO_Empty,
  input  wire [C_NUM_PORTS-1:0]                        PI_RdFIFO_Flush
);

  
  localparam C_INIT0_STALL               = 0;
  localparam C_INIT1_STALL               = 0;
  localparam C_INIT2_STALL               = 0;
  localparam C_ECC_ENCODE_PIPELINE  = 1'b1;
  localparam C_ECC_DECODE_PIPELINE  = 1'b1;
  
   
  localparam C_RAMB_SIM_COLLISION_CHECK = "NONE";
  localparam C_ARB_PORT_ENCODING_WIDTH       = 3; // Allowed Values: 3
  localparam C_ARB_PATTERN_TYPE_WIDTH        = 4; // Allowed Values: 4
  localparam C_ARB_PATTERN_TYPE_DECODE_WIDTH = 16; // Allowed Values: 16
  localparam C_ARB_SEQUENCE_ENCODING_WIDTH   = 4; // Allowed Values: 4
  localparam C_ARB_BRAM_ADDR_WIDTH           = 9; // Allowed Values: 9
  
  // FIFO localparams
  localparam C_RD_FIFO_APP_PIPELINE = {
                  C_PI7_RD_FIFO_APP_PIPELINE[0], C_PI6_RD_FIFO_APP_PIPELINE[0],
                  C_PI5_RD_FIFO_APP_PIPELINE[0], C_PI4_RD_FIFO_APP_PIPELINE[0],
                  C_PI3_RD_FIFO_APP_PIPELINE[0], C_PI2_RD_FIFO_APP_PIPELINE[0],
                  C_PI1_RD_FIFO_APP_PIPELINE[0], C_PI0_RD_FIFO_APP_PIPELINE[0]
                  };
  localparam C_RD_FIFO_MEM_PIPELINE = {C_PI7_RD_FIFO_MEM_PIPELINE[0], C_PI6_RD_FIFO_MEM_PIPELINE[0],
                                      C_PI5_RD_FIFO_MEM_PIPELINE[0], C_PI4_RD_FIFO_MEM_PIPELINE[0],
                                      C_PI3_RD_FIFO_MEM_PIPELINE[0], C_PI2_RD_FIFO_MEM_PIPELINE[0],
                                      C_PI1_RD_FIFO_MEM_PIPELINE[0], C_PI0_RD_FIFO_MEM_PIPELINE[0]};
  localparam C_WR_FIFO_APP_PIPELINE = {C_PI7_WR_FIFO_APP_PIPELINE[0], C_PI6_WR_FIFO_APP_PIPELINE[0],
                                      C_PI5_WR_FIFO_APP_PIPELINE[0], C_PI4_WR_FIFO_APP_PIPELINE[0],
                                      C_PI3_WR_FIFO_APP_PIPELINE[0], C_PI2_WR_FIFO_APP_PIPELINE[0],
                                      C_PI1_WR_FIFO_APP_PIPELINE[0], C_PI0_WR_FIFO_APP_PIPELINE[0]};
  localparam C_WR_FIFO_MEM_PIPELINE = {C_PI7_WR_FIFO_MEM_PIPELINE[0], C_PI6_WR_FIFO_MEM_PIPELINE[0],
                                      C_PI5_WR_FIFO_MEM_PIPELINE[0], C_PI4_WR_FIFO_MEM_PIPELINE[0],
                                      C_PI3_WR_FIFO_MEM_PIPELINE[0], C_PI2_WR_FIFO_MEM_PIPELINE[0],
                                      C_PI1_WR_FIFO_MEM_PIPELINE[0], C_PI0_WR_FIFO_MEM_PIPELINE[0]};
  localparam C_WR_FIFO_MEM_PIPELINE_SINGLE = 
             (C_PI0_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[0] :
             (C_PI1_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[1] :
             (C_PI2_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[2] :
             (C_PI3_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[3] :
             (C_PI4_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[4] :
             (C_PI5_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[5] :
             (C_PI6_WR_FIFO_TYPE != "DISABLED") ? C_WR_FIFO_MEM_PIPELINE[6] :
                                                  C_WR_FIFO_MEM_PIPELINE[7];
  // Per port FIFO parameters
  localparam C_PI_WR_FIFO_TYPE={((C_PI7_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI7_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI6_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI6_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI5_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI5_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI4_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI4_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI3_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI3_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI2_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI2_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI1_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI1_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI0_WR_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI0_WR_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10)};
  localparam C_PI_RD_FIFO_TYPE={((C_PI7_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI7_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI6_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI6_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI5_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI5_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI4_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI4_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI3_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI3_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI2_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI2_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI1_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI1_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10),
                                ((C_PI0_RD_FIFO_TYPE == "DISABLED") ? 2'b00 :
                                 (C_PI0_RD_FIFO_TYPE == "BRAM")     ? 2'b11 :
                                                                      2'b10)};

  localparam C_CTRL_DP_WRFIFO_WHICHPORT_REP = (C_MEM_DATA_WIDTH_INT<16) ? 
                                              1 : C_MEM_DATA_WIDTH_INT/16;
  localparam RDF_PUSH_BITS = ( C_MEM_TYPE == "SDRAM" ? 1 : (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH));    
  localparam P_WDF_RDEN_EARLY            = (C_WR_FIFO_MEM_PIPELINE_SINGLE == 1);
  localparam P_DELAY_PHYIF_DP_WRFIFO_POP = (C_WR_DATAPATH_TML_PIPELINE == 0);
  
  // V5 Phy Interface
  localparam P_ECC_DQ_BITS  = (C_ECC_DATA_WIDTH==0)  ? 0 :
                             (C_ECC_DATA_WIDTH<=2)  ? 1 :
                             (C_ECC_DATA_WIDTH<=4)  ? 2 :
                             (C_ECC_DATA_WIDTH<=8)  ? 3 :
                             (C_ECC_DATA_WIDTH<=16) ? 4 :
                             (C_ECC_DATA_WIDTH<=32) ? 5 :
                             (C_ECC_DATA_WIDTH<=64) ? 6 :
                                                      7;
  localparam P_DQ_BITS      = (C_MEM_DATA_WIDTH==1)  ? 1 :
                             (C_MEM_DATA_WIDTH==2)  ? 1 :
                             (C_MEM_DATA_WIDTH==4)  ? 2 :
                             (C_MEM_DATA_WIDTH==8)  ? 3 :
                             (C_MEM_DATA_WIDTH==16) ? 4 :
                             (C_MEM_DATA_WIDTH==32) ? 5 :
                             (C_MEM_DATA_WIDTH==64) ? 6 :
                                                      7;
  localparam P_ECC_DQS_BITS = (C_ECC_DQS_WIDTH==0)  ? 0 :
                             (C_ECC_DQS_WIDTH<=2)  ? 1 :
                             (C_ECC_DQS_WIDTH<=4)  ? 2 :
                             (C_ECC_DQS_WIDTH<=8)  ? 3 :
                             (C_ECC_DQS_WIDTH<=16) ? 4:
                             (C_ECC_DQS_WIDTH<=32) ? 5 :
                             (C_ECC_DQS_WIDTH<=64) ? 6 :
                                                     7;
  localparam P_DQS_BITS     = (C_MEM_DQS_WIDTH==1)  ? 1 :
                             (C_MEM_DQS_WIDTH==2)  ? 1 :
                             (C_MEM_DQS_WIDTH==4)  ? 2 :
                             (C_MEM_DQS_WIDTH==8)  ? 3 :
                             (C_MEM_DQS_WIDTH==16) ? 4:
                             (C_MEM_DQS_WIDTH==32) ? 5 :
                             (C_MEM_DQS_WIDTH==64) ? 6 :
                                                     7;

  // Bused Port Interface Request/Acknowledge/Address Signals
  // Signals Between Modules
  wire                                        Clk_WrFIFO_TML;
  wire                                        Ctrl_Is_Write;
  wire                                        Ctrl_PhyIF_CE;
  wire                                        Ctrl_PhyIF_RAS_n;
  wire                                        Ctrl_PhyIF_CAS_n;
  wire                                        Ctrl_PhyIF_WE_n;
  wire [C_MEM_BANKADDR_WIDTH-1:0]             AP_PhyIF_BankAddr;
  wire [C_MEM_ADDR_WIDTH-1:0]                 AP_PhyIF_Addr;
  wire [C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS-1:0]  AP_PhyIF_CS_n;
  wire                                        Ctrl_PhyIF_CE_i;
  wire                                        Ctrl_PhyIF_RAS_n_i;
  wire                                        Ctrl_PhyIF_CAS_n_i;
  wire                                        Ctrl_PhyIF_WE_n_i;
  wire [C_MEM_BANKADDR_WIDTH-1:0]             AP_PhyIF_BankAddr_i;
  wire [C_MEM_ADDR_WIDTH-1:0]                 AP_PhyIF_Addr_i;
  wire [C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS-1:0]  AP_PhyIF_CS_n_i;
  wire [C_MEM_DATA_WIDTH_INT-1:0]             PhyIF_DP_DQ_I;
  wire [C_ECC_DATA_WIDTH*(C_IS_DDR+1)+C_MEM_DATA_WIDTH_INT-1:0] rd_data;
  wire [C_MEM_DATA_WIDTH_INT-1:0]             DP_PhyIF_DQ_O;
  wire [C_ECC_DATA_WIDTH*(C_IS_DDR+1)+C_MEM_DATA_WIDTH_INT-1:0] wdf_data;
  wire [C_MEM_DM_WIDTH_INT-1:0]               DP_PhyIF_BE_O;
  wire                                        Ctrl_RMW;
  wire                                        Ctrl_PhyIF_DQS_O;
  wire [C_MEM_DM_WIDTH_INT-1:0]               Ctrl_PhyIF_Force_DM;
  reg  [C_NUM_PORTS-1:0]                      Ctrl_PhyIF_Force_DM_d1;
  // synthesis attribute equivalent_register_removal of Ctrl_PhyIF_Force_DM_d1 is "no"
  reg  [C_NUM_PORTS-1:0]                      Ctrl_PhyIF_Force_DM_d1_i;
  wire                                        PhyIF_Ctrl_InitDone_tmp;
  reg                                         PhyIF_Ctrl_InitDone_tmp_d1a = 1'b0;
  // synthesis attribute equivalent_register_removal of PhyIF_Ctrl_InitDone_tmp_d1a is "no"
  reg                                         PhyIF_Ctrl_InitDone_tmp_d1b = 1'b0;
  // synthesis attribute equivalent_register_removal of PhyIF_Ctrl_InitDone_tmp_d1b is "no"
  reg [19:0]                                  PhyIF_Ctrl_InitDone = 20'b0;
  // synthesis attribute equivalent_register_removal of PhyIF_Ctrl_InitDone is "no"
  reg                                         PhyIF_Ctrl_InitDone_270 = 1'b0;
  // synthesis attribute equivalent_register_removal of PhyIF_Ctrl_InitDone_270 is "no"
  //   reg                                         InitDone;
  // synthesis attribute equivalent_register_removal of InitDone is "no"
  reg                                         InitDone_i = 1'b0;
  // synthesis attribute equivalent_register_removal of InitDone_i is "no"
  reg [C_NUM_PORTS-1:0]                       InitDone_i2 = {C_NUM_PORTS{1'b0}};
  // synthesis attribute equivalent_register_removal of InitDone_i2 is "no"
  wire                                        Ctrl_Refresh_Flag;

  wire [C_STATIC_PHY_NUM_REG*32-1:0]          static_phy_reg_out_i;
  wire [8*C_MEM_NUM_DIMMS-1:0]                SPD_AP_Total_Offset;
  wire [8*C_MEM_NUM_DIMMS-1:0]                SPD_AP_DIMM_Offset;
  wire [8*C_MEM_NUM_DIMMS-1:0]                SPD_AP_Rank_Offset;
  wire [8*C_MEM_NUM_DIMMS-1:0]                SPD_AP_Bank_Offset;
  wire [8*C_MEM_NUM_DIMMS-1:0]                SPD_AP_Row_Offset;
  wire [8*C_MEM_NUM_DIMMS-1:0]                SPD_AP_Col_Offset;
  wire [31:0]                                 AP_Ctrl_Addr;
  wire [3:0]                                  Ctrl_ECC_RdFIFO_Size;
  wire [3:0]                                  Ctrl_ECC_RdFIFO_Size_i;
  wire                                        Ctrl_ECC_RdFIFO_RNW;
  wire                                        Ctrl_ECC_RdFIFO_RNW_i;
  wire [31:0]                                 Ctrl_ECC_RdFIFO_Addr;
  wire [C_NUM_PORTS-1:0]                      Ctrl_AP_PI_Addr_CE;
  wire [2:0]                                  Ctrl_AP_Port_Select;
  wire                                        Ctrl_AP_Row_Col_Sel;
  wire                                        Ctrl_AP_Col_Cnt_Load;
  wire                                        Ctrl_AP_Col_Cnt_Enable;
  wire                                        Ctrl_AP_Col_W;
  wire                                        Ctrl_AP_Col_DW;
  wire                                        Ctrl_AP_Col_CL4;
  wire                                        Ctrl_AP_Col_CL8;
  wire                                        Ctrl_AP_Col_B16;
  wire                                        Ctrl_AP_Col_B32;
  wire                                        Ctrl_AP_Col_B64;
  wire                                        Ctrl_AP_Precharge_Addr10;
  wire                                        Ctrl_AP_Assert_All_CS;
  wire                                        Ctrl_AP_Pipeline1_CE;
  
  wire [C_ARB_SEQUENCE_ENCODING_WIDTH-1:0]    Arb_Sequence;
  wire                                        Arb_LoadSequence;

  wire [RDF_PUSH_BITS-1:0]                    PhyIF_DP_RdFIFO_Push_tmp; 
  wire                                        PhyIF_DP_RdFIFO_Push; 
  wire                                        Ctrl_DP_RdFIFO_Push; 
  wire [C_NUM_PORTS-1:0]                      Ctrl_DP_RdFIFO_WhichPort_Decode;
  wire [C_NUM_PORTS-1:0]                      Ctrl_DP_RdFIFO_WhichPort_Decode_i;
  wire [C_NUM_PORTS-1:0]                      DP_Ctrl_RdFIFO_AlmostFull;

  wire [C_NUM_PORTS*4-1:0]                    Ctrl_DP_Size;

  wire [C_NUM_PORTS-1:0]                      PhyIF_DP_WrFIFO_Pop;
  reg  [C_NUM_PORTS-1:0]                      PhyIF_DP_WrFIFO_Pop_i;
  wire [3*C_CTRL_DP_WRFIFO_WHICHPORT_REP-1:0] Ctrl_DP_WrFIFO_WhichPort;
  wire [C_NUM_PORTS-1:0]                      Ctrl_DP_WrFIFO_WhichPort_Decode;
  wire [C_NUM_PORTS-1:0]                      DP_Ctrl_WrFIFO_Empty;

  wire [63:0]                                 PhyIF_Init_Data_tmp;
  wire [C_MEM_DATA_WIDTH_INT-1:0]             PhyIF_Init_Data;
  wire [C_MEM_DATA_WIDTH_INT-1:0]             PhyIF_Init_Data_reorder;
  wire                                        PhyIF_Init_Push_tmp;
  wire                                        PhyIF_Init_Push;

  wire [C_ECC_DM_WIDTH_INT+C_MEM_DM_WIDTH_INT-1:0] wdf_mask_data;

  reg                                         rst_phy;
  
  genvar i;
  
  /////////////////////////////////////////////////////////////////
  // This generate statement vecorizes the port interface inputs
  // based on the number of ports attached to the MPMC.
  /////////////////////////////////////////////////////////////////
  generate
     if      (C_MEM_DATA_WIDTH_INT ==   8) begin : gen_reorder_initdata_8bit
        assign PhyIF_Init_Data_reorder = {PhyIF_Init_Data_tmp[11:8],
                                          PhyIF_Init_Data_tmp[3:0]};
     end
     else if (C_MEM_DATA_WIDTH_INT ==  16) begin : gen_reorder_initdata_16bit
        assign PhyIF_Init_Data_reorder = PhyIF_Init_Data_tmp[15:0];
     end
     else if (C_MEM_DATA_WIDTH_INT ==  32) begin : gen_reorder_initdata_32bit
        assign PhyIF_Init_Data_reorder = {PhyIF_Init_Data_tmp[31:24],
                                          PhyIF_Init_Data_tmp[15:8],
                                          PhyIF_Init_Data_tmp[23:16],
                                          PhyIF_Init_Data_tmp[7:0]};
     end
     else if (C_MEM_DATA_WIDTH_INT ==  64) begin : gen_reorder_initdata_64bit
        assign PhyIF_Init_Data_reorder = {PhyIF_Init_Data_tmp[63:56],
                                          PhyIF_Init_Data_tmp[47:40],
                                          PhyIF_Init_Data_tmp[31:24],
                                          PhyIF_Init_Data_tmp[15:8],
                                          PhyIF_Init_Data_tmp[55:48],
                                          PhyIF_Init_Data_tmp[39:32],
                                          PhyIF_Init_Data_tmp[23:16],
                                          PhyIF_Init_Data_tmp[7:0]};
     end
     else if (C_MEM_DATA_WIDTH_INT == 128) begin : gen_reorder_initdata_128bit
        assign PhyIF_Init_Data_reorder = {PhyIF_Init_Data_tmp[63:56],
                                          PhyIF_Init_Data_tmp[47:40],
                                          PhyIF_Init_Data_tmp[31:24],
                                          PhyIF_Init_Data_tmp[15:8],
                                          PhyIF_Init_Data_tmp[63:56],
                                          PhyIF_Init_Data_tmp[47:40],
                                          PhyIF_Init_Data_tmp[31:24],
                                          PhyIF_Init_Data_tmp[15:8],
                                          PhyIF_Init_Data_tmp[55:48],
                                          PhyIF_Init_Data_tmp[39:32],
                                          PhyIF_Init_Data_tmp[23:16],
                                          PhyIF_Init_Data_tmp[7:0],
                                          PhyIF_Init_Data_tmp[55:48],
                                          PhyIF_Init_Data_tmp[39:32],
                                          PhyIF_Init_Data_tmp[23:16],
                                          PhyIF_Init_Data_tmp[7:0]};
     end
  endgenerate

  generate
     if ((C_FAMILY == "spartan3") || 
         (C_FAMILY == "spartan3a") || 
         (C_FAMILY == "spartan3e") ||
         (C_USE_STATIC_PHY==1) ||
         (C_IS_DDR==0)) begin : gen_phyif_initpush_spartan
        assign PhyIF_Init_Data = {C_MEM_DATA_WIDTH_INT{1'b0}};
        assign PhyIF_Init_Push = 1'b0;
     end
     else begin : gen_phyif_initdata
        reg [C_MEM_DATA_WIDTH_INT-1:0] PhyIF_Init_Data_i;
        reg                            PhyIF_Init_Push_i;
        always @(posedge Clk0)
          begin
             PhyIF_Init_Data_i <= PhyIF_Init_Data_reorder;
             PhyIF_Init_Push_i <= PhyIF_Init_Push_tmp; 
          end
        assign PhyIF_Init_Data = PhyIF_Init_Data_i;
        assign PhyIF_Init_Push = PhyIF_Init_Push_i;
     end
  endgenerate
  
  generate
     if (C_INCLUDE_ECC_SUPPORT == 0)
       begin : gen_noecc
          assign PhyIF_DP_RdFIFO_Push = PhyIF_DP_RdFIFO_Push_tmp[0];
          assign Ctrl_DP_RdFIFO_WhichPort_Decode_i = Ctrl_DP_RdFIFO_WhichPort_Decode;
          assign PhyIF_DP_DQ_I = rd_data;
          assign wdf_mask_data = ~DP_PhyIF_BE_O;
          assign ECC_Intr = 1'b0; 
          assign ECC_Reg_Out = {C_ECC_NUM_REG{1'b0}};

          for (i=0;i<C_MEM_DATA_WIDTH_INT/8;i=i+1)
            begin : gen_wdf_data
               assign wdf_data[(i+1)*8-1:i*8] = DP_PhyIF_DQ_O[(i+1)*8-1:i*8];
            end
       end
     else
       begin : gen_ecc
         ecc_top
         #(
           .C_FAMILY                 (C_FAMILY),
           .C_NUM_PORTS              (C_NUM_PORTS),
           .C_USE_STATIC_PHY         (C_USE_STATIC_PHY),
           .C_IS_DDR                 (C_IS_DDR),
           .C_MEM_TYPE               (C_MEM_TYPE),
           .C_MEM_DATA_WIDTH         (C_MEM_DATA_WIDTH),
           .C_MEM_DATA_WIDTH_INT     (C_MEM_DATA_WIDTH_INT),
           .C_MEM_DQS_WIDTH          (C_MEM_DQS_WIDTH),
           .C_MEM_DM_WIDTH_INT       (C_MEM_DM_WIDTH_INT),
           .C_ECC_DATA_WIDTH         (C_ECC_DATA_WIDTH),
           .C_ECC_DATA_WIDTH_INT     (C_ECC_DATA_WIDTH_INT),
           .C_ECC_DQS_WIDTH          (C_ECC_DQS_WIDTH),
           .C_ECC_DM_WIDTH_INT       (C_ECC_DM_WIDTH_INT),
           .C_ECC_DECODE_PIPELINE    (C_ECC_DECODE_PIPELINE),
           .C_ECC_ENCODE_PIPELINE    (C_ECC_ENCODE_PIPELINE),
           .C_ECC_DEFAULT_ON         (C_ECC_DEFAULT_ON),
           .C_ECC_SEC_THRESHOLD      (C_ECC_SEC_THRESHOLD),
           .C_ECC_DEC_THRESHOLD      (C_ECC_DEC_THRESHOLD),
           .C_ECC_PEC_THRESHOLD      (C_ECC_PEC_THRESHOLD),
           .C_INCLUDE_ECC_TEST       (C_INCLUDE_ECC_TEST),
           .C_WR_FIFO_MEM_PIPELINE_SINGLE (C_WR_FIFO_MEM_PIPELINE_SINGLE),
           .C_ECC_NUM_REG            (C_ECC_NUM_REG),
           .C_WDF_RDEN_EARLY         (P_WDF_RDEN_EARLY),
           .RDF_PUSH_BITS            (RDF_PUSH_BITS),
           .C_DELAY_PHYIF_DP_WRFIFO_POP (P_DELAY_PHYIF_DP_WRFIFO_POP)
         )
         ecc_top_0
         (
           .Clk0                     (Clk0),
           .Clk90                    (Clk90),
           .Clk_WrFIFO_TML           (Clk_WrFIFO_TML),
           .Rst                      (Rst[C_NUM_PORTS*2+4]),
           .InitDone                 (InitDone),
           .Ctrl_DP_RdFIFO_WhichPort_Decode (Ctrl_DP_RdFIFO_WhichPort_Decode),
           .Ctrl_ECC_RdFIFO_Size_i   (Ctrl_ECC_RdFIFO_Size_i),
           .Ctrl_ECC_RdFIFO_RNW_i    (Ctrl_ECC_RdFIFO_RNW_i),
           .Ctrl_ECC_RdFIFO_Addr     (Ctrl_ECC_RdFIFO_Addr),
           .Ctrl_ECC_RdFIFO_Size     (Ctrl_ECC_RdFIFO_Size),
           .Ctrl_ECC_RdFIFO_RNW      (Ctrl_ECC_RdFIFO_RNW),
           .Ctrl_RMW                 (Ctrl_RMW),
           .Ctrl_DP_RdFIFO_WhichPort_Decode_i (Ctrl_DP_RdFIFO_WhichPort_Decode_i),
           .DP_PhyIF_BE_O            (DP_PhyIF_BE_O),
           .DP_PhyIF_DQ_O            (DP_PhyIF_DQ_O),
           .PhyIF_DP_RdFIFO_Push_tmp (PhyIF_DP_RdFIFO_Push_tmp), 
           .PhyIF_Ctrl_InitDone_19   (PhyIF_Ctrl_InitDone[19]),
           .PhyIF_DP_WrFIFO_Pop_i    (PhyIF_DP_WrFIFO_Pop_i),
           .PhyIF_Ctrl_InitDone_270  (PhyIF_Ctrl_InitDone_270),
           .PhyIF_DP_RdFIFO_Push     (PhyIF_DP_RdFIFO_Push),
           .PhyIF_DP_DQ_I            (PhyIF_DP_DQ_I),
           .rd_data                  (rd_data),
           .wdf_data                 (wdf_data),
           .wdf_mask_data            (wdf_mask_data),
           .ECC_Reg_In               (ECC_Reg_In),
           .ECC_Reg_CE               (ECC_Reg_CE),
           .ECC_Intr                 (ECC_Intr),
           .ECC_Reg_Out              (ECC_Reg_Out)
         );
       end
  endgenerate  

  always @(posedge Clk0) 
    begin
       PhyIF_Ctrl_InitDone_tmp_d1a <= PhyIF_Ctrl_InitDone_tmp;
       PhyIF_Ctrl_InitDone <= {20{PhyIF_Ctrl_InitDone_tmp_d1a}};
       InitDone_i  <= PhyIF_Ctrl_InitDone[0];
       InitDone_i2 <= {C_NUM_PORTS{InitDone_i}};
       InitDone    <= InitDone_i;
    end
  always @(posedge Clk_WrFIFO_TML) 
    begin
       PhyIF_Ctrl_InitDone_tmp_d1b <= PhyIF_Ctrl_InitDone_tmp;
       PhyIF_Ctrl_InitDone_270 <= PhyIF_Ctrl_InitDone_tmp_d1b;
    end

  assign PI_InitDone = InitDone_i2;
  assign PI_WrFIFO_Empty = DP_Ctrl_WrFIFO_Empty;

/* We need to tie off the bidirection signals that aren't being used  in the 
phy layer to pass through synthesis */
generate
  if (C_MEM_TYPE != "DDR2") begin : no_ddr2_phy
    assign DDR2_DQ   = {(C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH){1'b0}};
    assign DDR2_DQS  = {(C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH){1'b0}};
    assign DDR2_DQS_n  = {(C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH){1'b0}};
  end
endgenerate
generate
  if (C_MEM_TYPE != "DDR") begin : no_ddr_phy
    assign DDR_DQ   = {(C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH){1'b0}};
    assign DDR_DQS  = {(C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH){1'b0}};
  end
endgenerate
generate
  if (C_MEM_TYPE != "SDRAM") begin : no_sdram_phy
    assign SDRAM_DQ = {(C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH){1'b0}};
  end
endgenerate

  // Ties off the static Phy Reg if it's not being used
  assign Static_Phy_Reg_Out = (C_USE_STATIC_PHY == 1) ? static_phy_reg_out_i : 
                                                        {C_STATIC_PHY_NUM_REG{1'b0}};

   // Timing improvement for write path.  8:1 mux now has a full cycle,
   // rather than 3/4 cycle.
  generate 
    reg                                       Ctrl_PhyIF_CE_i2;
    reg                                       Ctrl_PhyIF_RAS_n_i2;
    reg                                       Ctrl_PhyIF_CAS_n_i2;
    reg                                       Ctrl_PhyIF_WE_n_i2;
    reg [C_MEM_BANKADDR_WIDTH-1:0]            AP_PhyIF_BankAddr_i2;
    reg [C_MEM_ADDR_WIDTH-1:0]                AP_PhyIF_Addr_i2;
    reg [C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS-1:0] AP_PhyIF_CS_n_i2;
    reg                                       Ctrl_Is_Write_i;
    if ((C_USE_STATIC_PHY == 0) &&
        (C_IS_DDR == 1) &&
        (C_INCLUDE_ECC_SUPPORT == 0) &&
        ((C_FAMILY == "spartan3") || 
         (C_FAMILY == "spartan3a") || 
         (C_FAMILY == "spartan3e"))) begin : gen_s3
      always @(posedge Clk_WrFIFO_TML) begin
        Ctrl_Is_Write_i      <= Ctrl_Is_Write;
        Ctrl_PhyIF_RAS_n_i2  <= Ctrl_PhyIF_RAS_n_i;
        Ctrl_PhyIF_CAS_n_i2  <= Ctrl_PhyIF_CAS_n_i;
        Ctrl_PhyIF_WE_n_i2   <= Ctrl_PhyIF_WE_n_i;
        Ctrl_PhyIF_CE_i2     <= Ctrl_PhyIF_CE_i;
        AP_PhyIF_BankAddr_i2 <= AP_PhyIF_BankAddr_i;
        AP_PhyIF_Addr_i2     <= AP_PhyIF_Addr_i;
        AP_PhyIF_CS_n_i2     <= AP_PhyIF_CS_n_i;
      end
    end
    else if ((C_USE_STATIC_PHY == 0) &&
        (C_IS_DDR == 1) &&
        (C_INCLUDE_ECC_SUPPORT == 1) &&
        ((C_FAMILY == "spartan3") || 
         (C_FAMILY == "spartan3a") || 
         (C_FAMILY == "spartan3e"))) begin : gen_s3
      //always @(*) begin
      always @(negedge Clk90) begin
        Ctrl_Is_Write_i      <= Ctrl_Is_Write;
        Ctrl_PhyIF_RAS_n_i2  <= Ctrl_PhyIF_RAS_n_i;
        Ctrl_PhyIF_CAS_n_i2  <= Ctrl_PhyIF_CAS_n_i;
        Ctrl_PhyIF_WE_n_i2   <= Ctrl_PhyIF_WE_n_i;
        Ctrl_PhyIF_CE_i2     <= Ctrl_PhyIF_CE_i;
        AP_PhyIF_BankAddr_i2 <= AP_PhyIF_BankAddr_i;
        AP_PhyIF_Addr_i2     <= AP_PhyIF_Addr_i;
        AP_PhyIF_CS_n_i2     <= AP_PhyIF_CS_n_i;
      end
    end
    else begin : gen_normal
      always @(posedge Clk0) begin
        Ctrl_Is_Write_i      <= Ctrl_Is_Write;
        Ctrl_PhyIF_RAS_n_i2  <= Ctrl_PhyIF_RAS_n_i;
        Ctrl_PhyIF_CAS_n_i2  <= Ctrl_PhyIF_CAS_n_i;
        Ctrl_PhyIF_WE_n_i2   <= Ctrl_PhyIF_WE_n_i;
        Ctrl_PhyIF_CE_i2     <= Ctrl_PhyIF_CE_i;
        AP_PhyIF_BankAddr_i2 <= AP_PhyIF_BankAddr_i;
        AP_PhyIF_Addr_i2     <= AP_PhyIF_Addr_i;
        AP_PhyIF_CS_n_i2     <= AP_PhyIF_CS_n_i;
      end
    end     
    assign Ctrl_PhyIF_RAS_n  = Ctrl_Is_Write_i ? Ctrl_PhyIF_RAS_n_i2 :
                                                 Ctrl_PhyIF_RAS_n_i;
    assign Ctrl_PhyIF_CAS_n  = Ctrl_Is_Write_i ? Ctrl_PhyIF_CAS_n_i2 :
                                                 Ctrl_PhyIF_CAS_n_i;
    assign Ctrl_PhyIF_WE_n   = Ctrl_Is_Write_i ? Ctrl_PhyIF_WE_n_i2 :
                                                 Ctrl_PhyIF_WE_n_i;
    assign Ctrl_PhyIF_CE     = Ctrl_Is_Write_i ? Ctrl_PhyIF_CE_i2 :
                                                 Ctrl_PhyIF_CE_i;
    assign AP_PhyIF_BankAddr = Ctrl_Is_Write_i ? AP_PhyIF_BankAddr_i2 :
                                                 AP_PhyIF_BankAddr_i;
    assign AP_PhyIF_Addr     = Ctrl_Is_Write_i ? AP_PhyIF_Addr_i2 :
                                                 AP_PhyIF_Addr_i;
    assign AP_PhyIF_CS_n     = Ctrl_Is_Write_i ? AP_PhyIF_CS_n_i2 :
                                                  AP_PhyIF_CS_n_i;
  endgenerate
   
/* Instantiate the Phy Layer */
  always @(posedge Clk0) rst_phy <= Rst[C_NUM_PORTS*2+1];
  generate
    if (C_USE_STATIC_PHY==1 && C_MEM_TYPE == "DDR2") 
      begin : gen_static_phy_ddr2
        static_phy_top #
          (
           .FAMILY         (C_FAMILY),
           //*****************************************************************
           .C_RDDATA_CLK_SEL   (C_STATIC_PHY_RDDATA_CLK_SEL),
           .C_RDDATA_SWAP_RISE (C_STATIC_PHY_RDDATA_SWAP_RISE),
           .C_RDEN_DELAY       (C_STATIC_PHY_RDEN_DELAY),
           .C_NUM_REG          (C_STATIC_PHY_NUM_REG),
           //*****************************************************************
           .WDF_RDEN_EARLY (P_WDF_RDEN_EARLY),
           .ECC_ENABLE     (C_INCLUDE_ECC_SUPPORT),
           .ADDITIVE_LAT   (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN      (C_MEM_BURST_LENGTH),
           .BURST_TYPE     (0),
           .CAS_LAT        (C_MEM_CAS_LATENCY0),
           .DQSN_ENABLE    (C_MEM_DQSN_ENABLE),
           .ODT_TYPE       (C_MEM_ODT_TYPE),
           .REDUCE_DRV     (C_MEM_REDUCED_DRV),
           .REG_ENABLE     (C_MEM_REG_DIMM),
           .DDR2_ENABLE    (C_MEM_DDR2_ENABLE),
           .WDF_RDEN_WIDTH (C_NUM_PORTS),
           .BANK_WIDTH     (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH      (C_MEM_CLK_WIDTH),
           .CKE_WIDTH      (C_MEM_CE_WIDTH),
           .COL_WIDTH      (C_MEM_ADDR_WIDTH),
           .CS_WIDTH       (C_MEM_CS_N_WIDTH),
           .DM_WIDTH       (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQ_WIDTH       (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQS_WIDTH      (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQ_PER_DQS     (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .ODT_WIDTH      (C_MEM_ODT_WIDTH),
           .ROW_WIDTH      (C_MEM_ADDR_WIDTH),
           .CS_NUM         (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CLK_PERIOD     (C_MEM_CLK_PERIOD),
           .SIM_ONLY       (C_SKIP_INIT_DELAY)
           )
          mpmc_phy_if_0
            (
             // Clocks/Resets
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             .clk0_rddata       (Clk_Mem),
             .dcm_en            (DCM_PSEN),
             .dcm_incdec        (DCM_PSINCDEC),
             .dcm_done          (DCM_PSDONE),
             .reg_ce            (Static_Phy_Reg_CE),
             .reg_in            (Static_Phy_Reg_In),
             .reg_out           (static_phy_reg_out_i),
             // Initialization Signals
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp), // Set to 0 from 
                                                     // rst until end of init 
                                                     // and calibration.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag), // One cycle high pulse
                                                     // every time refresh 
                                                     // is requested.
                                                     // Memory Control Signals
             .ctrl_addr         (AP_PhyIF_Addr),     // Pre IOB FF mem 
                                                     // address.
             .ctrl_ba           (AP_PhyIF_BankAddr), // Pre IOB FF mem 
                                                     // bank address.
             .ctrl_ras_n        (Ctrl_PhyIF_RAS_n),  // Pre IOB FF mem RAS.
             .ctrl_cas_n        (Ctrl_PhyIF_CAS_n),  // Pre IOB FF mem CAS.
             .ctrl_we_n         (Ctrl_PhyIF_WE_n),   // Pre IOB FF mem WE.
             .ctrl_cs_n         (AP_PhyIF_CS_n),     // Pre IOB FF mem CS.
             // Memory Write Signals
             .ctrl_wren         (Ctrl_PhyIF_DQS_O),  // Indicator that DQS
                                                     // should toggle.
             .wdf_data          (wdf_data),          // Pre IOB FF write 
                                                     // data.
             .wdf_mask_data     (wdf_mask_data),     // Pre IOB FF write 
                                                     // data mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop), // Write FIFO pop.
             // Memory Read Signals
             .ctrl_rden         (Ctrl_DP_RdFIFO_Push), // Pulse high for number
                                                     // of cycles read push 
                                                     // will be asserted. Needs
                                                     // to be high one cycle 
                                                     // befor ctrl_<ras/cas/we>
                                                     // indicate read.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp), // Rd FIFO push.
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2-1:0]), 
                                                     // Post IOB FF LSB read 
                                                     // data.
             .rd_data_fall      (rd_data[C_ECC_DATA_WIDTH*2+
                                         C_MEM_DATA_WIDTH_INT-1:
                                         C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2]),
                                                     // Post IOB FF MSB read 
                                                     // data.
             // Memory I/Os
             .ddr_ck            (Mem_Clk_O),      // Post IOB FF mem clock.
             .ddr_ck_n          (Mem_Clk_n_O),    // Post IOB FF mem inverse
                                                  // clock.
             .ddr_addr          (Mem_Addr_O),     // Post IOB FF mem address
             .ddr_ba            (Mem_BankAddr_O), // Post IOB FF mem bank 
                                                  // address.
             .ddr_ras_n         (Mem_RAS_n_O),    // Post IOB FF mem RAS.
             .ddr_cas_n         (Mem_CAS_n_O),    // Post IOB FF mem CAS.
             .ddr_we_n          (Mem_WE_n_O),     // Post IOB FF mem WE.
             .ddr_cs_n          (Mem_CS_n_O),     // Post IOB FF mem CS.
             .ddr_cke           (Mem_CE_O),       // Post IOB FF mem CKE.
             .ddr_odt           (Mem_ODT_O),      // Post IOB FF mem ODT.             
             .ddr_dm            (Mem_DM_O),       // Post IOB FF mem data 
                                                  // mask.
             .ddr_dqs           (DDR2_DQS),       // Post IOB FF mem data 
                                                  // strobe.
             .ddr_dqs_n         (DDR2_DQS_n),     // Post IOB FF mem data 
                                                  // strobe.
             .ddr_dq            (DDR2_DQ)         // Post IOB FF mem data.
             );
      end
    else if (C_USE_STATIC_PHY==1 && C_MEM_TYPE == "DDR")
      begin : gen_static_phy_ddr
        static_phy_top #
          (
           .FAMILY         (C_FAMILY),
           //******************************************************************
           .C_RDDATA_CLK_SEL   (C_STATIC_PHY_RDDATA_CLK_SEL),
           .C_RDDATA_SWAP_RISE (C_STATIC_PHY_RDDATA_SWAP_RISE),
           .C_RDEN_DELAY       (C_STATIC_PHY_RDEN_DELAY),
           .C_NUM_REG          (C_STATIC_PHY_NUM_REG),
           //******************************************************************
           .WDF_RDEN_EARLY (P_WDF_RDEN_EARLY),
           .ECC_ENABLE     (C_INCLUDE_ECC_SUPPORT),
           .ADDITIVE_LAT   (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN      (C_MEM_BURST_LENGTH),
           .BURST_TYPE     (0),
           .CAS_LAT        (C_MEM_CAS_LATENCY0),
           .DQSN_ENABLE    (C_MEM_DQSN_ENABLE),
           .ODT_TYPE       (C_MEM_ODT_TYPE),
           .REDUCE_DRV     (C_MEM_REDUCED_DRV),
           .REG_ENABLE     (C_MEM_REG_DIMM),
           .DDR2_ENABLE    (C_MEM_DDR2_ENABLE),
           .WDF_RDEN_WIDTH (C_NUM_PORTS),
           .BANK_WIDTH     (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH      (C_MEM_CLK_WIDTH),
           .CKE_WIDTH      (C_MEM_CE_WIDTH),
           .COL_WIDTH      (C_MEM_ADDR_WIDTH),
           .CS_WIDTH       (C_MEM_CS_N_WIDTH),
           .DM_WIDTH       (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQ_WIDTH       (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQS_WIDTH      (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQ_PER_DQS     (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .ODT_WIDTH      (C_MEM_ODT_WIDTH),
           .ROW_WIDTH      (C_MEM_ADDR_WIDTH),
           .CS_NUM         (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CLK_PERIOD     (C_MEM_CLK_PERIOD),
           .SIM_ONLY       (C_SKIP_INIT_DELAY)
           )
          mpmc_phy_if_0
            (
             // Clocks/Resets
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             .clk0_rddata       (Clk_Mem),
             .dcm_en            (DCM_PSEN),
             .dcm_incdec        (DCM_PSINCDEC),
             .dcm_done          (DCM_PSDONE),
             .reg_ce            (Static_Phy_Reg_CE),
             .reg_in            (Static_Phy_Reg_In),
             .reg_out           (static_phy_reg_out_i),
             // Initialization Signals
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp), // Set to 0 from rst
                                                     // until end of init and 
                                                     // calibration.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag), // One cycle high pulse
                                                     // every time refresh 
                                                     // is requested.
             // Memory Control Signals
             .ctrl_addr         (AP_PhyIF_Addr),     // Pre IOB FF mem 
                                                     // address.
             .ctrl_ba           (AP_PhyIF_BankAddr), // Pre IOB FF mem 
                                                     // bank address.
             .ctrl_ras_n        (Ctrl_PhyIF_RAS_n),  // Pre IOB FF mem RAS.
             .ctrl_cas_n        (Ctrl_PhyIF_CAS_n),  // Pre IOB FF mem CAS.
             .ctrl_we_n         (Ctrl_PhyIF_WE_n),   // Pre IOB FF mem WE.
             .ctrl_cs_n         (AP_PhyIF_CS_n),     // Pre IOB FF mem CS.
             // Memory Write Signals
             .ctrl_wren         (Ctrl_PhyIF_DQS_O),  // Indicator that DQS
                                                     // should toggle.
             .wdf_data          (wdf_data),          // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),     // Pre IOB FF write data
                                                     // mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop.
             // Memory Read Signals
             .ctrl_rden         (Ctrl_DP_RdFIFO_Push),// Pulse high for number 
                                                     // of cycles read push 
                                                     // will be // asserted.  
                                                     // Needs to be high one 
                                                     // cycle before 
                                                     // ctrl_<ras/cas/we> 
                                                     // indicate read.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp),// Rd FIFO push.
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2-1:0]), 
                                                     // Post IOB FF LSB read 
                                                     // data.
             .rd_data_fall      (rd_data[C_ECC_DATA_WIDTH*2+
                                         C_MEM_DATA_WIDTH_INT-1:
                                         C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2]), 
                                                     // Post IOB FF MSB read 
                                                     // data.
             // Memory I/Os
             .ddr_ck            (Mem_Clk_O),      // Post IOB FF mem clock.
             .ddr_ck_n          (Mem_Clk_n_O),    // Post IOB FF mem inverse
                                                  // clock.
             .ddr_addr          (Mem_Addr_O),     // Post IOB FF mem address
             .ddr_ba            (Mem_BankAddr_O), // Post IOB FF mem bank 
                                                  // address.
             .ddr_ras_n         (Mem_RAS_n_O),    // Post IOB FF mem RAS.
             .ddr_cas_n         (Mem_CAS_n_O),    // Post IOB FF mem CAS.
             .ddr_we_n          (Mem_WE_n_O),     // Post IOB FF mem WE.
             .ddr_cs_n          (Mem_CS_n_O),     // Post IOB FF mem CS.
             .ddr_cke           (Mem_CE_O),       // Post IOB FF mem CKE.
             .ddr_odt           (Mem_ODT_O),      // Post IOB FF mem ODT.
             .ddr_dm            (Mem_DM_O),       // Post IOB FF mem data mask.
             .ddr_dqs           (DDR_DQS),        // Post IOB FF mem data 
                                                  // strobe.
             .ddr_dqs_n         (),
             .ddr_dq            (DDR_DQ)          // Post IOB FF mem data.
             );
      end
    else if (C_FAMILY == "virtex5" && C_MEM_TYPE == "DDR2")
      begin : gen_v5_ddr2_phy
        wire [(C_ECC_DATA_WIDTH*(C_IS_DDR+1)+
              C_MEM_DATA_WIDTH_INT)/8*5-1:0] dbg_calib_rden_dly;
        wire [C_ECC_DATA_WIDTH*(C_IS_DDR+1)+
              C_MEM_DATA_WIDTH_INT-1:0] rd_data_tmp;
        wire [RDF_PUSH_BITS-1:0] PhyIF_DP_RdFIFO_Push_tmp2; 
        reg Ctrl_DP_RdFIFO_Push_d1;

        always @(posedge Clk0)
          Ctrl_DP_RdFIFO_Push_d1 <= Ctrl_DP_RdFIFO_Push;
  
        mpmc_realign_bytes #
          (
           .C_IS_DDR      (C_IS_DDR),
           .C_DATA_WIDTH  ((C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH)*(C_IS_DDR+1)),
           .C_DELAY_WIDTH (5)
           )
          mpmc_realign_bytes_0
            (
             .Clk        (Clk0),
             .Data_Delay (dbg_calib_rden_dly),
             .Data_In    (rd_data_tmp),
             .Data_Out   (rd_data),
             .Push_In    (PhyIF_DP_RdFIFO_Push_tmp2),
             .Push_Out   (PhyIF_DP_RdFIFO_Push_tmp)
             );
  
        v5_phy_top_ddr2 #
          (
           .BANK_WIDTH            (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH             (C_MEM_CLK_WIDTH),
           .CKE_WIDTH             (C_MEM_CE_WIDTH),
           .COL_WIDTH             (C_MEM_ADDR_WIDTH),
           .CS_NUM                (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH              (C_MEM_CS_N_WIDTH),
           .USE_DM_PORT           (1),
           .DM_WIDTH              (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQ_WIDTH              (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQ_BITS               (P_ECC_DQ_BITS+P_DQ_BITS),
           .DQ_PER_DQS            (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .DQS_WIDTH             (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQS_BITS              (P_ECC_DQS_BITS+P_DQS_BITS),
           .HIGH_PERFORMANCE_MODE ("TRUE"),
           .ODT_WIDTH             (C_MEM_ODT_WIDTH),
           .ROW_WIDTH             (C_MEM_ADDR_WIDTH),
           .ADDITIVE_LAT          (C_MEM_ADDITIVE_LATENCY),
           .TWO_T_TIME_EN         (0),
           .BURST_LEN             (C_MEM_BURST_LENGTH),
           .BURST_TYPE            (0),
           .CAS_LAT               (C_MEM_CAS_LATENCY0),
           .TWR                   (C_TWR),
           .ECC_ENABLE            (C_INCLUDE_ECC_SUPPORT),
           .ODT_TYPE              (C_MEM_ODT_TYPE),
           .DDR_TYPE              (C_MEM_DDR2_ENABLE),
           .REDUCE_DRV            (C_MEM_REDUCED_DRV),
           .REG_ENABLE            (C_MEM_REG_DIMM),
           .CLK_PERIOD            (C_MEM_CLK_PERIOD),
           .SIM_ONLY              (C_SKIP_INIT_DELAY),
           .DEBUG_EN              (0),
           .DQS_IO_COL            (C_MEM_DQS_IO_COL),
           .DQ_IO_MS              (C_MEM_DQ_IO_MS),
           .DQSN_ENABLE           (C_MEM_DQSN_ENABLE),
           .WDF_RDEN_EARLY        (P_WDF_RDEN_EARLY),
           .WDF_RDEN_WIDTH        (C_NUM_PORTS)
           )
          mpmc_phy_if_0 
            (
             // Clocks/Resets
             .clk0               (Clk0),
             .clk90              (Clk90),
             .clkdiv0            (Clk0_DIV2),
             .rst0               (rst_phy),
             .rst90              (Rst90),
             .rstdiv0            (rst_phy),
             // Memory Control Signals
             .ctrl_wren          (Ctrl_PhyIF_DQS_O),  // Indicator that DQS 
                                                      // should toggle.
             .ctrl_addr          (AP_PhyIF_Addr),     // Pre IOB FF memory 
                                                      // address.
             .ctrl_ba            (AP_PhyIF_BankAddr), // Pre IOB FF memory 
                                                      // bank address.
             .ctrl_ras_n         (Ctrl_PhyIF_RAS_n),  // Pre IOB FF memory RAS.
             .ctrl_cas_n         (Ctrl_PhyIF_CAS_n),  // Pre IOB FF memory CAS.
             .ctrl_we_n          (Ctrl_PhyIF_WE_n),   // Pre IOB FF memory WE.
             .ctrl_cs_n          (AP_PhyIF_CS_n),     // Pre IOB FF memory CS.
             .ctrl_rden          (C_INCLUDE_ECC_SUPPORT ? 
                                  Ctrl_DP_RdFIFO_Push_d1 : 
                                  Ctrl_DP_RdFIFO_Push),// Pulse high for 
                                                      // number of cycles read 
                                                      // push will be asserted.
                                                      // Needs to be high one 
                                                      // cycle before
                                                      // ctrl_<ras/cas/we> 
                                                      // indicate read.
             .ctrl_ref_flag      (Ctrl_Refresh_Flag), // One cycle high pulse 
                                                      // every time refresh is 
                                                      // requested.
             // Memory Write Signals
             .wdf_data           (wdf_data),          // Pre IOB FF write data.
             .wdf_mask_data      (wdf_mask_data),     // Pre IOB FF write data 
                                                      // mask.
             .wdf_rden           (PhyIF_DP_WrFIFO_Pop),// Wr FIFO pop signal.
             // Initialization Signals
             .phy_init_done      (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                      // reset until end of 
                                                      // initialization and 
                                                      // calibration.
             // Memory Read Signals
             .phy_calib_rden     (PhyIF_DP_RdFIFO_Push_tmp2),// Read FIFO push.
             .phy_calib_rden_sel (),
             .rd_data_rise      (rd_data_tmp[C_ECC_DATA_WIDTH+
                                             C_MEM_DATA_WIDTH_INT/2-1:0]),
                                                      // Post IOB FF LSB read 
                                                      // data.
             .rd_data_fall      (rd_data_tmp[C_ECC_DATA_WIDTH*2+
                                             C_MEM_DATA_WIDTH_INT-1:
                                             C_ECC_DATA_WIDTH+
                                             C_MEM_DATA_WIDTH_INT/2]),
                                                      // Post IOB FF MSB read 
                                                      // data.
             // Memory I/Os
             .ddr_ck            (Mem_Clk_O),      // Post IOB FF memory clock.
             .ddr_ck_n          (Mem_Clk_n_O),    // Post IOB FF memory inverse
                                                  // clock.
             .ddr_addr          (Mem_Addr_O),     // Post IOB FF memory addr.
             .ddr_ba            (Mem_BankAddr_O), // Post IOB FF memory bank 
                                                  // address.
             .ddr_ras_n         (Mem_RAS_n_O),    // Post IOB FF memory RAS.
             .ddr_cas_n         (Mem_CAS_n_O),    // Post IOB FF memory CAS.
             .ddr_we_n          (Mem_WE_n_O),     // Post IOB FF memory WE.
             .ddr_cs_n          (Mem_CS_n_O),     // Post IOB FF memory CS.
             .ddr_cke           (Mem_CE_O),       // Post IOB FF memory CKE.
             .ddr_odt           (Mem_ODT_O),      // Post IOB FF memory ODT.
             .ddr_dm            (Mem_DM_O),       // Post IOB FF memory data 
                                                  // mask.
             .ddr_dqs           (DDR2_DQS),       // Post IOB FF memory data 
                                                  // strobe.
             .ddr_dqs_n         (DDR2_DQS_n),     // Post IOB FF memory inverse
                                                  // data strobe.
             .ddr_dq            (DDR2_DQ),        // Post IOB FF memory data.
             // Debug signals
             .dbg_idel_up_all        (1'b0),
             .dbg_idel_down_all      (1'b0),
             .dbg_idel_up_dq         (1'b0),
             .dbg_idel_down_dq       (1'b0),
             .dbg_idel_up_dqs        (1'b0),
             .dbg_idel_down_dqs      (1'b0),
             .dbg_idel_up_gate       (1'b0),
             .dbg_idel_down_gate     (1'b0),
             .dbg_sel_idel_dq        ({P_ECC_DQ_BITS+P_DQ_BITS{1'b0}}),
             .dbg_sel_all_idel_dq    (1'b0),
             .dbg_sel_idel_dqs       ({P_ECC_DQS_BITS+P_DQS_BITS{1'b0}}),
             .dbg_sel_all_idel_dqs   (1'b0),
             .dbg_sel_idel_gate      ({P_ECC_DQS_BITS+P_DQS_BITS{1'b0}}),
             .dbg_sel_all_idel_gate  (1'b0),
             .dbg_calib_done         (),
             .dbg_calib_err          (),
             .dbg_calib_dq_tap_cnt   (),
             .dbg_calib_dqs_tap_cnt  (),
             .dbg_calib_gate_tap_cnt (),
             .dbg_calib_rd_data_sel  (),
             .dbg_calib_rden_dly     (dbg_calib_rden_dly),
             .dbg_calib_gate_dly     ()
             );
        assign PhyIF_Init_Push_tmp = 1'b0;
        assign PhyIF_Init_Data_tmp = 64'h0;
//               .phy_init_wdf_wren (PhyIF_Init_Push_tmp),     // O  -- Push signal for phy_init_wdf_data.
//               .phy_init_wdf_data (PhyIF_Init_Data_tmp),     // O  -- Write training pattern to be pushed into write FIFO's during initialization
        end // block: gen_ddr2_phy
    else if (C_FAMILY == "virtex5" && C_MEM_TYPE == "DDR")
      begin : gen_v5_ddr_phy
        wire [(C_ECC_DATA_WIDTH*(C_IS_DDR+1)+
              C_MEM_DATA_WIDTH_INT)/8*2-1:0] dbg_calib_rden_dly;
        wire [C_ECC_DATA_WIDTH*(C_IS_DDR+1)+
              C_MEM_DATA_WIDTH_INT-1:0] rd_data_tmp;
        wire [RDF_PUSH_BITS-1:0] PhyIF_DP_RdFIFO_Push_tmp2; 

        mpmc_realign_bytes #
          (
           .C_IS_DDR      (C_IS_DDR),
           .C_DATA_WIDTH  ((C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH)*(C_IS_DDR+1)),
           .C_DELAY_WIDTH (2)
           )
          mpmc_realign_bytes_0
            (
             .Clk        (Clk0),
             .Data_Delay (dbg_calib_rden_dly),
             .Data_In    (rd_data_tmp),
             .Data_Out   (rd_data),
             .Push_In    (PhyIF_DP_RdFIFO_Push_tmp2),
             .Push_Out   (PhyIF_DP_RdFIFO_Push_tmp)
             );
  
        v5_phy_top_ddr1 #
          (
           .BANK_WIDTH            (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH             (C_MEM_CLK_WIDTH),
           .CKE_WIDTH             (C_MEM_CE_WIDTH),
           .COL_WIDTH             (C_MEM_ADDR_WIDTH),
           .CS_NUM                (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH              (C_MEM_CS_N_WIDTH),
           .USE_DM_PORT           (1),
           .DM_WIDTH              (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQ_WIDTH              (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQ_BITS               (P_ECC_DQ_BITS+P_DQ_BITS),
           .DQ_PER_DQS            (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .DQS_BITS              (P_ECC_DQS_BITS+P_DQS_BITS),
           .DQS_WIDTH             (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .HIGH_PERFORMANCE_MODE ("TRUE"),
           .ODT_WIDTH             (C_MEM_ODT_WIDTH),
           .ROW_WIDTH             (C_MEM_ADDR_WIDTH),
           .ADDITIVE_LAT          (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN             (C_MEM_BURST_LENGTH),
           .BURST_TYPE            (0),
           .CAS_LAT               (C_MEM_CAS_LATENCY0),
           .ECC_ENABLE            (C_INCLUDE_ECC_SUPPORT),
           .ODT_TYPE              (C_MEM_ODT_TYPE),
           .REDUCE_DRV            (C_MEM_REDUCED_DRV),
           .REG_ENABLE            (C_MEM_REG_DIMM),
           .CLK_PERIOD            (C_MEM_CLK_PERIOD),
           .DDR2_ENABLE           (C_MEM_DDR2_ENABLE),
           .DQS_GATE_EN           (C_MEM_DQS_GATE_EN),
           .SIM_ONLY              (C_SKIP_INIT_DELAY),
           .WDF_RDEN_EARLY        (P_WDF_RDEN_EARLY),
           .WDF_RDEN_WIDTH        (C_NUM_PORTS),
           .DEBUG_EN              (0)
           )
          mpmc_phy_if_0 
            (
             // Clocks/Resets
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             // Memory Control Signals
             .ctrl_wren         (Ctrl_PhyIF_DQS_O),  // Indicator that DQS 
                                                     // should toggle.
             .ctrl_addr         (AP_PhyIF_Addr),     // Pre IOB FF memory addr.
             .ctrl_ba           (AP_PhyIF_BankAddr), // Pre IOB FF memory bank 
                                                     // address.
             .ctrl_ras_n        (Ctrl_PhyIF_RAS_n),  // Pre IOB FF memory RAS.
             .ctrl_cas_n        (Ctrl_PhyIF_CAS_n),  // Pre IOB FF memory CAS.
             .ctrl_we_n         (Ctrl_PhyIF_WE_n),   // Pre IOB FF memory WE.
             .ctrl_cs_n         (AP_PhyIF_CS_n),     // Pre IOB FF memory CS.
             .ctrl_rden         (Ctrl_DP_RdFIFO_Push),// Pulse high for number 
                                                     // of cycles read push 
                                                     // will be asserted.  
                                                     // Needs to be high one 
                                                     // cycle before 
                                                     // ctrl_<ras/cas/we> 
                                                     // indicate read.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag), // One cycle high pulse 
                                                     // every time refresh is 
                                                     // requested.
             // Memory Write Signals
             .wdf_data          (wdf_data),          // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),     // Pre IOB FF write data 
                                                     // mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop signal.
             // Initialization Signals
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                     // reset until end of 
                                                     // initialization and 
                                                     // calibration.
             // Memory Read Signals
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp2),// Read FIFO push.
             .phy_init_wdf_wren (PhyIF_Init_Push_tmp),// Push signal for 
                                                     // phy_init_wdf_data.
             .phy_init_wdf_data (PhyIF_Init_Data_tmp),// Write training pattern
                                                     // to be pushed into
                                                     //write FIFO's during 
                                                     // initialization
             .rd_data_rise      (rd_data_tmp[C_ECC_DATA_WIDTH+
                                             C_MEM_DATA_WIDTH_INT/2-1:0]),
                                                     // Post IOB FF LSB read 
                                                     // data.
             .rd_data_fall      (rd_data_tmp[C_ECC_DATA_WIDTH*2+
                                             C_MEM_DATA_WIDTH_INT-1:
                                             C_ECC_DATA_WIDTH+
                                             C_MEM_DATA_WIDTH_INT/2]),
                                                     // Post IOB FF MSB read 
                                                     // data.
             // Memory I/Os
             .ddr_ck            (Mem_Clk_O),      // Post IOB FF memory clock.
             .ddr_ck_n          (Mem_Clk_n_O),    // Post IOB FF memory inverse
                                                  // clock.
             .ddr_addr          (Mem_Addr_O),     // Post IOB FF memory address
             .ddr_ba            (Mem_BankAddr_O), // Post IOB FF memory bank 
                                                  // address.
             .ddr_ras_n         (Mem_RAS_n_O),    // Post IOB FF memory RAS.
             .ddr_cas_n         (Mem_CAS_n_O),    // Post IOB FF memory CAS.
             .ddr_we_n          (Mem_WE_n_O),     // Post IOB FF memory WE.
             .ddr_cs_n          (Mem_CS_n_O),     // Post IOB FF memory CS.
             .ddr_cke           (Mem_CE_O),       // Post IOB FF memory CKE.
             .ddr_odt           (Mem_ODT_O),      // Post IOB FF memory ODT.
             .ddr_dm            (Mem_DM_O),       // Post IOB FF memory data 
                                                  // mask.
             .ddr_dqs           (DDR_DQS),        // Post IOB FF memory data 
                                                  // strobe.
             .ddr_dqs_n         (), 
             .ddr_dq            (DDR_DQ),         // Post IOB FF memory data.
             // Debug signals
             .dbg_calib_done         (),
             .dbg_calib_err          (),
             .dbg_calib_dq_tap_cnt   (),
             .dbg_calib_dqs_tap_cnt  (),
             .dbg_calib_gate_tap_cnt (),
             .dbg_calib_rden_dly     (dbg_calib_rden_dly),
             .dbg_calib_gate_dly     ()
             );
        
      end
    else if (C_FAMILY === "virtex4" && C_MEM_TYPE == "DDR2")
      begin : gen_v4_ddr2_phy
        v4_phy_top #
          (
           .TBY4TAPVALUE        (C_TBY4TAPVALUE),
           .WDF_RDEN_EARLY      (P_WDF_RDEN_EARLY),
           .WDF_RDEN_WIDTH      (C_NUM_PORTS),
           .BANK_WIDTH          (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH           (C_MEM_CLK_WIDTH),
           .CKE_WIDTH           (C_MEM_CE_WIDTH),
           .COL_WIDTH           (C_MEM_ADDR_WIDTH),
           .CS_NUM              (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH            (C_MEM_CS_N_WIDTH),
           .DM_WIDTH            (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQS_WIDTH           (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQ_WIDTH            (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQ_PER_DQS          (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .ODT_WIDTH           (C_MEM_ODT_WIDTH),
           .ROW_WIDTH           (C_MEM_ADDR_WIDTH),
           .ADDITIVE_LAT        (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN           (C_MEM_BURST_LENGTH),
           .BURST_TYPE          (0),
           .CAS_LAT             (C_MEM_CAS_LATENCY0),
           .ECC_ENABLE          (C_INCLUDE_ECC_SUPPORT),
           .ECC_ENCODE_PIPELINE (C_ECC_ENCODE_PIPELINE),
           .DQSN_ENABLE         (C_MEM_DQSN_ENABLE),
           .ODT_TYPE            (C_MEM_ODT_TYPE),
           .REDUCE_DRV          (C_MEM_REDUCED_DRV),
           .REG_ENABLE          (C_MEM_REG_DIMM),
	   .TWR                 (C_TWR),
           .CLK_PERIOD          (C_MEM_CLK_PERIOD),
           .DDR2_ENABLE         (C_MEM_DDR2_ENABLE),
           .DQS_GATE_EN         (C_MEM_DQS_GATE_EN),
           .IDEL_HIGH_PERF      (C_MEM_IDEL_HIGH_PERF),
           .SIM_ONLY            (C_SKIP_INIT_DELAY)
           )
          mpmc_phy_if_0 
            (
             // Clocks/Resets
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             // Initialization Signals
             .phy_init_wdf_wren (PhyIF_Init_Push_tmp),// Push signal for 
                                                     // phy_init_wdf_data.
             .phy_init_wdf_data (PhyIF_Init_Data_tmp),// Write training pattern
                                                     // to be pushed into write
                                                     // FIFO's during 
                                                     // initialization
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                     // reset until end of 
                                                     // initialization and 
                                                     // calibration.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag), // One cycle high pulse 
                                                     // every time refresh is 
                                                     // requested.
             // Memory Control Signals
             .ctrl_addr         (AP_PhyIF_Addr),     // Pre IOB FF mem address.
             .ctrl_ba           (AP_PhyIF_BankAddr), // Pre IOB FF mem bank 
                                                     // address.
             .ctrl_ras_n        (Ctrl_PhyIF_RAS_n),  // Pre IOB FF memory RAS.
             .ctrl_cas_n        (Ctrl_PhyIF_CAS_n),  // Pre IOB FF memory CAS.
             .ctrl_we_n         (Ctrl_PhyIF_WE_n),   // Pre IOB FF memory WE.
             .ctrl_cs_n         (AP_PhyIF_CS_n),     // Pre IOB FF memory CS.
             // Memory Write Signals
             .ctrl_wren         (Ctrl_PhyIF_DQS_O),  // Indicator that DQS 
                                                     // should toggle.
             .wdf_data          (wdf_data),          // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),     // Pre IOB FF write data 
                                                     // mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop signal.
             // Memory Read Signals
             .ctrl_rden         (Ctrl_DP_RdFIFO_Push),// Pulse high for number 
                                                     // of cycles read push 
                                                     // will be asserted.  
                                                     // Needs to be high one 
                                                     // cycle before 
                                                     // ctrl_<ras/cas/we> 
                                                     // indicate read.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp),// Read FIFO push.
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2-1:0]),
                                                     // Post IOB FF LSB read 
                                                     // data.
             .rd_data_fall      (rd_data[C_ECC_DATA_WIDTH*2+
                                         C_MEM_DATA_WIDTH_INT-1:
                                         C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2]),
                                                     // Post IOB FF MSB read 
                                                     // data.
             // Memory I/Os
             .ddr_ck            (Mem_Clk_O),      // Post IOB FF memory clock.
             .ddr_ck_n          (Mem_Clk_n_O),    // Post IOB FF memory inverse
                                                  // clock.
             .ddr_addr          (Mem_Addr_O),     // Post IOB FF memory addr.
             .ddr_ba            (Mem_BankAddr_O), // Post IOB FF memory bank 
                                                  // address.
             .ddr_ras_n         (Mem_RAS_n_O),    // Post IOB FF memory RAS.
             .ddr_cas_n         (Mem_CAS_n_O),    // Post IOB FF memory CAS.
             .ddr_we_n          (Mem_WE_n_O),     // Post IOB FF memory WE.
             .ddr_cs_n          (Mem_CS_n_O),     // Post IOB FF memory CS.
             .ddr_cke           (Mem_CE_O),       // Post IOB FF memory CKE.
             .ddr_odt           (Mem_ODT_O),      // Post IOB FF memory ODT.
             
             .ddr_addr_2        (Mem_Addr_O_2),     // Post IOB FF memory addr.
             .ddr_ba_2          (Mem_BankAddr_O_2), // Post IOB FF memory bank 
                                                  // address.
             .ddr_ras_n_2       (Mem_RAS_n_O_2),    // Post IOB FF memory RAS.
             .ddr_cas_n_2       (Mem_CAS_n_O_2),    // Post IOB FF memory CAS.
             .ddr_we_n_2        (Mem_WE_n_O_2),     // Post IOB FF memory WE.
             .ddr_cs_n_2        (Mem_CS_n_O_2),     // Post IOB FF memory CS.
             .ddr_cke_2         (Mem_CE_O_2),       // Post IOB FF memory CKE.
             .ddr_odt_2         (Mem_ODT_O_2),      // Post IOB FF memory ODT.

             .ddr_dm            (Mem_DM_O),       // Post IOB FF memory data 
                                                  // mask.
             .ddr_dqs           (DDR2_DQS),       // Post IOB FF memory data 
                                                  // strobe.
             .ddr_dqs_n         (DDR2_DQS_n),     // Post IOB FF memory inverse
                                                  // data strobe.
             .ddr_dq            (DDR2_DQ)         // Post IOB FF memory data.
             );
      end
    else if (C_FAMILY === "virtex4" && C_MEM_TYPE == "DDR")
      begin : gen_v4_ddr_phy
        v4_phy_top #
          (
           .TBY4TAPVALUE        (C_TBY4TAPVALUE),
           .WDF_RDEN_EARLY      (P_WDF_RDEN_EARLY),
           .WDF_RDEN_WIDTH      (C_NUM_PORTS),
           .BANK_WIDTH          (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH           (C_MEM_CLK_WIDTH),
           .CKE_WIDTH           (C_MEM_CE_WIDTH),
           .COL_WIDTH           (C_MEM_ADDR_WIDTH),
           .CS_NUM              (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH            (C_MEM_CS_N_WIDTH),
           .DM_WIDTH            (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQS_WIDTH           (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQ_WIDTH            (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQ_PER_DQS          (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .ODT_WIDTH           (C_MEM_ODT_WIDTH),
           .ROW_WIDTH           (C_MEM_ADDR_WIDTH),
           .ADDITIVE_LAT        (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN           (C_MEM_BURST_LENGTH),
           .BURST_TYPE          (0),
           .CAS_LAT             (C_MEM_CAS_LATENCY0),
           .ECC_ENABLE          (C_INCLUDE_ECC_SUPPORT),
           .ECC_ENCODE_PIPELINE (C_ECC_ENCODE_PIPELINE),
           .DQSN_ENABLE         (C_MEM_DQSN_ENABLE),
           .ODT_TYPE            (C_MEM_ODT_TYPE),
           .REDUCE_DRV          (C_MEM_REDUCED_DRV),
           .REG_ENABLE          (C_MEM_REG_DIMM),
	   .TWR                 (C_TWR),
           .CLK_PERIOD          (C_MEM_CLK_PERIOD),
           .DDR2_ENABLE         (C_MEM_DDR2_ENABLE),
           .DQS_GATE_EN         (C_MEM_DQS_GATE_EN),
           .IDEL_HIGH_PERF      (C_MEM_IDEL_HIGH_PERF),
           .SIM_ONLY            (C_SKIP_INIT_DELAY)
           )
          mpmc_phy_if_0 
            (
             // Clocks/Resets
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             // Initialization Signals
             .phy_init_wdf_wren (PhyIF_Init_Push_tmp),// Push signal for 
                                                     // phy_init_wdf_data.
             .phy_init_wdf_data (PhyIF_Init_Data_tmp),// Write training pattern
                                                     // to be pushed into
                                                     // write FIFO's during 
                                                     // initialization
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                     // reset until end of 
                                                     // initialization and 
                                                     // calibration.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag), // One cycle high pulse 
                                                     // every time refresh is 
                                                     // requested.
             // Memory Control Signals
             .ctrl_addr         (AP_PhyIF_Addr),     // Pre IOB FF mem address.
             .ctrl_ba           (AP_PhyIF_BankAddr), // Pre IOB FF memory bank 
                                                     // address.
             .ctrl_ras_n        (Ctrl_PhyIF_RAS_n),  // Pre IOB FF memory RAS.
             .ctrl_cas_n        (Ctrl_PhyIF_CAS_n),  // Pre IOB FF memory CAS.
             .ctrl_we_n         (Ctrl_PhyIF_WE_n),   // Pre IOB FF memory WE.
             .ctrl_cs_n         (AP_PhyIF_CS_n),     // Pre IOB FF memory CS.
             // Memory Write Signals
             .ctrl_wren         (Ctrl_PhyIF_DQS_O),  // Indicator that DQS 
                                                     // should toggle.
             .wdf_data          (wdf_data),          // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),     // Pre IOB FF write data 
                                                     // mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop signal.
             // Memory Read Signals
             .ctrl_rden         (Ctrl_DP_RdFIFO_Push),// Pulse high for number 
                                                     // of cycles read push 
                                                     // will be asserted.  
                                                     // Needs to be high one 
                                                     // cycle before 
                                                     // ctrl_<ras/cas/we> 
                                                     // indicate read.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp),// Read FIFO push.
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2-1:0]),
                                                     // Post IOB FF LSB read 
                                                     // data.
             .rd_data_fall      (rd_data[C_ECC_DATA_WIDTH*2+
                                         C_MEM_DATA_WIDTH_INT-1:
                                         C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2]),
                                                     // Post IOB FF MSB read 
                                                     // data.
             // Memory I/Os
             .ddr_ck            (Mem_Clk_O),      // Post IOB FF memory clock.
             .ddr_ck_n          (Mem_Clk_n_O),    // Post IOB FF memory inverse
                                                  // clock.
             .ddr_addr          (Mem_Addr_O),     // Post IOB FF mem address.
             .ddr_ba            (Mem_BankAddr_O), // Post IOB FF memory bank 
                                                  // address.
             .ddr_ras_n         (Mem_RAS_n_O),    // Post IOB FF memory RAS.
             .ddr_cas_n         (Mem_CAS_n_O),    // Post IOB FF memory CAS.
             .ddr_we_n          (Mem_WE_n_O),     // Post IOB FF memory WE.
             .ddr_cs_n          (Mem_CS_n_O),     // Post IOB FF memory CS.
             .ddr_cke           (Mem_CE_O),       // Post IOB FF memory CKE.
             .ddr_odt           (Mem_ODT_O),      // Post IOB FF memory ODT.
             .ddr_dm            (Mem_DM_O),       // Post IOB FF memory data 
                                                  // mask.
             .ddr_dqs           (DDR_DQS),        // Post IOB FF memory data 
                                                  // strobe.
             .ddr_dqs_n         (), 
             .ddr_dq            (DDR_DQ)          // Post IOB FF memory data.
             );
      end
    else if (((C_FAMILY == "spartan3") || (C_FAMILY == "spartan3a") || (C_FAMILY == "spartan3e")) && C_MEM_TYPE == "DDR2")
      begin : gen_s3_ddr2_phy
        reg                                       ctrl_wren_i;
        reg [C_MEM_ADDR_WIDTH-1:0]                ctrl_addr_i;
        reg [C_MEM_BANKADDR_WIDTH-1:0]            ctrl_ba_i;
        reg                                       ctrl_ras_n_i;
        reg                                       ctrl_cas_n_i;
        reg                                       ctrl_we_n_i;
        reg [C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS-1:0] ctrl_cs_n_i;
        reg                                       ctrl_rden_i;
        if (C_INCLUDE_ECC_SUPPORT == 1) begin : gen_ecc
          reg                                       Ctrl_DP_RdFIFO_Push_d1;
          always @(posedge Clk0) begin
            Ctrl_DP_RdFIFO_Push_d1 <= Ctrl_DP_RdFIFO_Push;
            ctrl_wren_i  <= Ctrl_PhyIF_DQS_O;
            ctrl_rden_i <= Ctrl_Is_Write ? Ctrl_DP_RdFIFO_Push_d1 :
                                           Ctrl_DP_RdFIFO_Push;
          end
          always @(negedge Clk90) begin
            ctrl_addr_i  <= AP_PhyIF_Addr;
            ctrl_ba_i    <= AP_PhyIF_BankAddr;
            ctrl_ras_n_i <= Ctrl_PhyIF_RAS_n;
            ctrl_cas_n_i <= Ctrl_PhyIF_CAS_n;
            ctrl_we_n_i  <= Ctrl_PhyIF_WE_n;
            ctrl_cs_n_i  <= AP_PhyIF_CS_n;
          end
        end else begin : gen_noecc
          always @(*) begin
            ctrl_wren_i  <= Ctrl_PhyIF_DQS_O;
            ctrl_rden_i  <= Ctrl_DP_RdFIFO_Push;
            ctrl_addr_i  <= AP_PhyIF_Addr;
            ctrl_ba_i    <= AP_PhyIF_BankAddr;
            ctrl_ras_n_i <= Ctrl_PhyIF_RAS_n;
            ctrl_cas_n_i <= Ctrl_PhyIF_CAS_n;
            ctrl_we_n_i  <= Ctrl_PhyIF_WE_n;
            ctrl_cs_n_i  <= AP_PhyIF_CS_n;
          end
        end
        s3_phy_top #
          (
           .BANK_WIDTH     (C_MEM_BANKADDR_WIDTH),
           .ROW_WIDTH      (C_MEM_ADDR_WIDTH),
           .COL_WIDTH      (C_MEM_ADDR_WIDTH),
           .CLK_WIDTH      (C_MEM_CLK_WIDTH),
           .CKE_WIDTH      (C_MEM_CE_WIDTH),
           .CS_NUM         (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH       (C_MEM_CS_N_WIDTH),
           .DM_WIDTH       (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           //.DQ_BITS        (P_DQ_BITS),
           .DQ_BITS        (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQ_PER_DQS     (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .DQS_BITS       (P_ECC_DQS_BITS+P_DQS_BITS),
           .DQS_WIDTH      (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQSN_ENABLE    (C_MEM_DQSN_ENABLE),
           .ODT_WIDTH      (C_MEM_ODT_WIDTH),
           .ADDITIVE_LAT   (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN      (C_MEM_BURST_LENGTH),
           .BURST_TYPE     (0),
           .CAS_LAT        (C_MEM_CAS_LATENCY0),
           .ECC_ENABLE     (C_INCLUDE_ECC_SUPPORT),
           .ODT_TYPE       (C_MEM_ODT_TYPE),
           .REDUCE_DRV     (C_MEM_REDUCED_DRV),
           .REG_ENABLE     (C_MEM_REG_DIMM),
	   .TWR            (C_TWR),
           .CLK_PERIOD     (C_MEM_CLK_PERIOD),
           .DDR2_ENABLE    (C_MEM_DDR2_ENABLE),
           .DQS_GATE_EN    (C_MEM_DQS_GATE_EN),
           .IDEL_HIGH_PERF (C_MEM_IDEL_HIGH_PERF),
           .WDF_RDEN_WIDTH (C_NUM_PORTS),
           .WDF_RDEN_EARLY (P_WDF_RDEN_EARLY),
           .SIM_ONLY       (C_SKIP_INIT_DELAY),
           .C_FAMILY       (C_FAMILY),
           .C_SPECIAL_BOARD(C_SPECIAL_BOARD),
           .C_DEBUG_EN     (0)
           )
          mpmc_phy_if_0 
            (
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             .ctrl_wren         (ctrl_wren_i),  // Indicator that DQS should toggle.
             .ctrl_addr         (ctrl_addr_i),  // Pre IOB FF memory address.
             .ctrl_ba           (ctrl_ba_i), // Pre IOB FF memory bank address.
             .ctrl_ras_n        (ctrl_ras_n_i), // Pre IOB FF memory RAS.
             .ctrl_cas_n        (ctrl_cas_n_i), // Pre IOB FF memory CAS.
             .ctrl_we_n         (ctrl_we_n_i),  // Pre IOB FF memory WE.
             .ctrl_cs_n         (ctrl_cs_n_i),  // Pre IOB FF memory CS.
             .ctrl_rden         (ctrl_rden_i),  // Pulse high for number of cycles read push will be asserted.  Needs to be high one cycle before ctrl_<ras/cas/we> indicate read.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag),// One cycle high pulse every time refresh is requested.
             .wdf_data          (wdf_data),         // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),    // Pre IOB FF write data mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop signal.
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                    // reset until end of 
                                                    // initialization and 
                                                    // calibration.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp),// Read FIFO push.
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2-1:0]),
                                                    // Post IOB FF LSB rd data.
             .rd_data_fall      (rd_data[C_ECC_DATA_WIDTH*2+
                                         C_MEM_DATA_WIDTH_INT-1:
                                         C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2]),
                                                    // Post IOB FF MSB rd data.
             .ddr_ck            (Mem_Clk_O),     // Post IOB FF memory clock.
             .ddr_ck_n          (Mem_Clk_n_O),   // Post IOB FF memory inverse 
                                                 // clock.
             .ddr_addr          (Mem_Addr_O),    // Post IOB FF memory address.
             .ddr_ba            (Mem_BankAddr_O),// Post IOB FF memory bank 
                                                 // address.
             .ddr_ras_n         (Mem_RAS_n_O),   // Post IOB FF memory RAS.
             .ddr_cas_n         (Mem_CAS_n_O),   // Post IOB FF memory CAS.
             .ddr_we_n          (Mem_WE_n_O),    // Post IOB FF memory WE.
             .ddr_cs_n          (Mem_CS_n_O),    // Post IOB FF memory CS.
             .ddr_cke           (Mem_CE_O),      // Post IOB FF memory CKE.
             .ddr_odt           (Mem_ODT_O),     // Post IOB FF memory ODT.
             .ddr_dm            (Mem_DM_O),      // Post IOB FF memory data 
                                                 // mask.
             .ddr_dqs           (DDR2_DQS),      // Post IOB FF memory data 
                                                 // strobe.
             .ddr_dqs_n         (DDR2_DQS_n),    // Post IOB FF memory inverse 
                                                 // data strobe.
             .ddr_dq            (DDR2_DQ),       // Post IOB FF memory data.
             .rst_dqs_div_out   (Mem_DQS_Div_O), // Post IOB DQS for calib
             .rst_dqs_div_in    (Mem_DQS_Div_I), // Input feedback from 
                                                 // Mem_dqs_div_out
             .dbg_delay_sel     (),
             .dbg_rst_calib     (),
	     .vio_out_dqs            (5'b0),
	     .vio_out_dqs_en         (1'b0),
	     .vio_out_rst_dqs_div    (5'b0),
	     .vio_out_rst_dqs_div_en (1'b0)
             );
      end
    else if (((C_FAMILY == "spartan3") || (C_FAMILY == "spartan3a") || (C_FAMILY == "spartan3e")) && C_MEM_TYPE == "DDR")
      begin : gen_s3_ddr_phy
        reg                                       ctrl_wren_i;
        reg [C_MEM_ADDR_WIDTH-1:0]                ctrl_addr_i;
        reg [C_MEM_BANKADDR_WIDTH-1:0]            ctrl_ba_i;
        reg                                       ctrl_ras_n_i;
        reg                                       ctrl_cas_n_i;
        reg                                       ctrl_we_n_i;
        reg [C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS-1:0] ctrl_cs_n_i;
        reg                                       ctrl_rden_i;
        if (C_INCLUDE_ECC_SUPPORT == 1) begin : gen_ecc
          reg                                       Ctrl_DP_RdFIFO_Push_d1;
          always @(posedge Clk0) begin
            Ctrl_DP_RdFIFO_Push_d1 <= Ctrl_DP_RdFIFO_Push;
            ctrl_wren_i  <= Ctrl_PhyIF_DQS_O;
            ctrl_rden_i <= Ctrl_Is_Write ? Ctrl_DP_RdFIFO_Push_d1 :
                                           Ctrl_DP_RdFIFO_Push;
          end
          always @(negedge Clk90) begin
            ctrl_addr_i  <= AP_PhyIF_Addr;
            ctrl_ba_i    <= AP_PhyIF_BankAddr;
            ctrl_ras_n_i <= Ctrl_PhyIF_RAS_n;
            ctrl_cas_n_i <= Ctrl_PhyIF_CAS_n;
            ctrl_we_n_i  <= Ctrl_PhyIF_WE_n;
            ctrl_cs_n_i  <= AP_PhyIF_CS_n;
          end
        end else begin : gen_noecc
          always @(*) begin
            ctrl_wren_i  <= Ctrl_PhyIF_DQS_O;
            ctrl_rden_i  <= Ctrl_DP_RdFIFO_Push;
            ctrl_addr_i  <= AP_PhyIF_Addr;
            ctrl_ba_i    <= AP_PhyIF_BankAddr;
            ctrl_ras_n_i <= Ctrl_PhyIF_RAS_n;
            ctrl_cas_n_i <= Ctrl_PhyIF_CAS_n;
            ctrl_we_n_i  <= Ctrl_PhyIF_WE_n;
            ctrl_cs_n_i  <= AP_PhyIF_CS_n;
          end
        end
        s3_phy_top #
          (
           .BANK_WIDTH     (C_MEM_BANKADDR_WIDTH),
           .ROW_WIDTH      (C_MEM_ADDR_WIDTH),
           .COL_WIDTH      (C_MEM_ADDR_WIDTH),
           .CLK_WIDTH      (C_MEM_CLK_WIDTH),
           .CKE_WIDTH      (C_MEM_CE_WIDTH),
           .CS_NUM         (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH       (C_MEM_CS_N_WIDTH),
           .DM_WIDTH       (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           //.DQ_BITS        (P_DQ_BITS),
           .DQ_BITS        (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .DQ_PER_DQS     (C_MEM_DATA_WIDTH/C_MEM_DQS_WIDTH),
           .DQS_BITS       (P_ECC_DQS_BITS+P_DQS_BITS),
           .DQS_WIDTH      (C_ECC_DQS_WIDTH+C_MEM_DQS_WIDTH),
           .DQSN_ENABLE    (C_MEM_DQSN_ENABLE),
           .ODT_WIDTH      (C_MEM_ODT_WIDTH),
           .ADDITIVE_LAT   (C_MEM_ADDITIVE_LATENCY),
           .BURST_LEN      (C_MEM_BURST_LENGTH),
           .BURST_TYPE     (0),
           .CAS_LAT        (C_MEM_CAS_LATENCY0),
           .ECC_ENABLE     (C_INCLUDE_ECC_SUPPORT),
           .ODT_TYPE       (C_MEM_ODT_TYPE),
           .REDUCE_DRV     (C_MEM_REDUCED_DRV),
           .REG_ENABLE     (C_MEM_REG_DIMM),
	   .TWR            (C_TWR),
           .CLK_PERIOD     (C_MEM_CLK_PERIOD),
           .DDR2_ENABLE    (C_MEM_DDR2_ENABLE),
           .DQS_GATE_EN    (C_MEM_DQS_GATE_EN),
           .IDEL_HIGH_PERF (C_MEM_IDEL_HIGH_PERF),
           .WDF_RDEN_WIDTH (C_NUM_PORTS),
           .WDF_RDEN_EARLY (P_WDF_RDEN_EARLY),
           .SIM_ONLY       (C_SKIP_INIT_DELAY),
           .C_FAMILY       (C_FAMILY),
           .C_SPECIAL_BOARD(C_SPECIAL_BOARD),
           .C_DEBUG_EN     (0)
           )
          mpmc_phy_if_0 
            (
             .clk0              (Clk0),
             .clk90             (Clk90),
             .rst0              (rst_phy),
             .rst90             (Rst90),
             .ctrl_wren         (ctrl_wren_i),      // Indicator that DQS 
                                                    // should toggle.
             .ctrl_addr         (ctrl_addr_i),      // Pre IOB FF mem address.
             .ctrl_ba           (ctrl_ba_i),        // Pre IOB FF memory bank 
                                                    // address.
             .ctrl_ras_n        (ctrl_ras_n_i),     // Pre IOB FF memory RAS.
             .ctrl_cas_n        (ctrl_cas_n_i),     // Pre IOB FF memory CAS.
             .ctrl_we_n         (ctrl_we_n_i),      // Pre IOB FF memory WE.
             .ctrl_cs_n         (ctrl_cs_n_i),      // Pre IOB FF memory CS.
             .ctrl_rden         (ctrl_rden_i),      // Pulse high for number 
                                                    // of cycles read push will
                                                    // be asserted.  Needs to 
                                                    // be high one cycle before
                                                    // ctrl_<ras/cas/we> 
                                                    // indicate read.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag),// One cycle high pulse 
                                                    // every time refresh is 
                                                    // requested.
             .wdf_data          (wdf_data),         // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),    // Pre IOB FF write data 
                                                    // mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop signal.
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                    // reset until end of 
                                                    // initialization and 
                                                    // calibration.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp),// Read FIFO push.
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2-1:0]),
                                                    // Post IOB FF LSB rd data.
             .rd_data_fall      (rd_data[C_ECC_DATA_WIDTH*2+
                                         C_MEM_DATA_WIDTH_INT-1:
                                         C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT/2]),
                                                    // Post IOB FF MSB rd data.
             .ddr_ck            (Mem_Clk_O),     // Post IOB FF memory clock.
             .ddr_ck_n          (Mem_Clk_n_O),   // Post IOB FF memory inverse 
                                                 // clock.
             .ddr_addr          (Mem_Addr_O),    // Post IOB FF memory address.
             .ddr_ba            (Mem_BankAddr_O),// Post IOB FF memory bank 
                                                 // address.
             .ddr_ras_n         (Mem_RAS_n_O),   // Post IOB FF memory RAS.
             .ddr_cas_n         (Mem_CAS_n_O),   // Post IOB FF memory CAS.
             .ddr_we_n          (Mem_WE_n_O),    // Post IOB FF memory WE.
             .ddr_cs_n          (Mem_CS_n_O),    // Post IOB FF memory CS.
             .ddr_cke           (Mem_CE_O),      // Post IOB FF memory CKE.
             .ddr_odt           (Mem_ODT_O),     // Post IOB FF memory ODT.
             .ddr_dm            (Mem_DM_O),      // Post IOB FF memory data 
                                                 // mask.
             .ddr_dqs           (DDR_DQS),       // Post IOB FF memory data 
                                                 // strobe.
             .ddr_dqs_n         (),              // Post IOB FF memory inverse 
                                                 // data strobe.
             .ddr_dq            (DDR_DQ),        // Post IOB FF memory data.
             .rst_dqs_div_out   (Mem_DQS_Div_O), // Post IOB DQS for calib
             .rst_dqs_div_in    (Mem_DQS_Div_I), // Input feedback from 
                                                 // Mem_dqs_div_out
             .dbg_delay_sel     (),
             .dbg_rst_calib     (),
	     .vio_out_dqs            (5'b0),
	     .vio_out_dqs_en         (1'b0),
	     .vio_out_rst_dqs_div    (5'b0),
	     .vio_out_rst_dqs_div_en (1'b0)
             );
      end
    else if ( C_MEM_TYPE == "SDRAM" )
      begin : gen_sdram_phy
        assign PhyIF_Init_Push_tmp = 1'b0;
        assign PhyIF_Init_Data_tmp = 63'b0;
        phy_top_sdram #
          (
           .WDF_RDEN_EARLY      (P_WDF_RDEN_EARLY),
           .WDF_RDEN_WIDTH      (C_NUM_PORTS),
           .BANK_WIDTH          (C_MEM_BANKADDR_WIDTH),
           .CLK_WIDTH           (C_MEM_CLK_WIDTH),
           .CKE_WIDTH           (C_MEM_CE_WIDTH),
           .COL_WIDTH           (C_MEM_ADDR_WIDTH),
           .CS_NUM              (C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS),
           .CS_WIDTH            (C_MEM_CS_N_WIDTH),
           .DM_WIDTH            (C_ECC_DM_WIDTH+C_MEM_DM_WIDTH),
           .DQ_WIDTH            (C_ECC_DATA_WIDTH+C_MEM_DATA_WIDTH),
           .ROW_WIDTH           (C_MEM_ADDR_WIDTH),
           .BURST_LEN           (C_MEM_BURST_LENGTH),
           .BURST_TYPE          (0),
           .CAS_LAT             (C_MEM_CAS_LATENCY0),
           .ECC_ENABLE          (C_INCLUDE_ECC_SUPPORT),
           .REG_ENABLE          (C_MEM_REG_DIMM),
           .SIM_ONLY            (C_SKIP_INIT_DELAY)
           )
          mpmc_phy_if_0 
            (
             // Clocks/Resets
             .clk0              (Clk0),
             .rst0              (rst_phy),
             .phy_init_done     (PhyIF_Ctrl_InitDone_tmp),// Set to 0 from 
                                                    // reset until end of 
                                                    // initialization and 
                                                    // calibration.
             .ctrl_ref_flag     (Ctrl_Refresh_Flag),// One cycle high pulse 
                                                    // every time refresh is 
                                                    // requested.
             // Memory Control Signals
             .ctrl_addr         (AP_PhyIF_Addr),    // Pre IOB FF mem address.
             .ctrl_ba           (AP_PhyIF_BankAddr),// Pre IOB FF memory bank 
                                                    // address.
             .ctrl_ras_n        (Ctrl_PhyIF_RAS_n), // Pre IOB FF memory RAS.
             .ctrl_cas_n        (Ctrl_PhyIF_CAS_n), // Pre IOB FF memory CAS.
             .ctrl_we_n         (Ctrl_PhyIF_WE_n),  // Pre IOB FF memory WE.
             .ctrl_cs_n         (AP_PhyIF_CS_n),    // Pre IOB FF memory CS.
             // Memory Write Signals
             .ctrl_wren         (Ctrl_PhyIF_DQS_O), // Indicator that DQS 
                                                    // should toggle.
             .wdf_data          (wdf_data),         // Pre IOB FF write data.
             .wdf_mask_data     (wdf_mask_data),    // Pre IOB FF write data 
                                                    // mask.
             .wdf_rden          (PhyIF_DP_WrFIFO_Pop),// Write FIFO pop signal.
             // Memory Read Signals
             .ctrl_rden         (Ctrl_DP_RdFIFO_Push),// Pulse high for number 
                                                    // of cycles read push will
                                                    // be asserted. Needs to be
                                                    // high one cycle before 
                                                    // ctrl_<ras/cas/we> 
                                                    // indicate read.
             .phy_calib_rden    (PhyIF_DP_RdFIFO_Push_tmp),// Read FIFO push .
             .rd_data_rise      (rd_data[C_ECC_DATA_WIDTH+
                                         C_MEM_DATA_WIDTH_INT-1:0]),
                                                    // Post IOB FF LSB rd data.
             // Memory I/Os
             .sdram_ck          (Mem_Clk_O),     // Post IOB FF memory clock.
             .sdram_ck_n        (Mem_Clk_n_O),   // Post IOB FF memory inverse 
                                                 // clock.
             .sdram_addr        (Mem_Addr_O),    // Post IOB FF memory address.
             .sdram_ba          (Mem_BankAddr_O),// Post IOB FF memory bank 
                                                 // address.
             .sdram_ras_n       (Mem_RAS_n_O),   // Post IOB FF memory RAS.
             .sdram_cas_n       (Mem_CAS_n_O),   // Post IOB FF memory CAS.
             .sdram_we_n        (Mem_WE_n_O),    // Post IOB FF memory WE.
             .sdram_cs_n        (Mem_CS_n_O),    // Post IOB FF memory CS.
             .sdram_cke         (Mem_CE_O),      // Post IOB FF memory CKE.
             .sdram_dm          (Mem_DM_O),      // Post IOB FF memory data 
                                                 // mask.
             .sdram_dq          (SDRAM_DQ)       // Post IOB FF memory data.
             );
      end        
    
  endgenerate

 
   // Address Path
   function [7:0] decode_offset;
      input [31:0] n;
      reg [8:0] j;
      begin
         for (j = 0; j < 32; j = j + 1) begin
            if (n[j]) decode_offset = j;
         end
      end   
   endfunction

   generate
      if (C_MEM_NUM_DIMMS==2)
        begin : SPD_Offsets_2_DIMMS
           assign SPD_AP_Total_Offset = {decode_offset(C_MEM_SUPPORTED_TOTAL_OFFSETS),decode_offset(C_MEM_SUPPORTED_TOTAL_OFFSETS)};
           assign SPD_AP_DIMM_Offset  = {decode_offset(C_MEM_SUPPORTED_DIMM_OFFSETS),decode_offset(C_MEM_SUPPORTED_DIMM_OFFSETS)};
           assign SPD_AP_Rank_Offset  = {decode_offset(C_MEM_SUPPORTED_RANK_OFFSETS),decode_offset(C_MEM_SUPPORTED_RANK_OFFSETS)};
           assign SPD_AP_Bank_Offset  = {decode_offset(C_MEM_SUPPORTED_BANK_OFFSETS),decode_offset(C_MEM_SUPPORTED_BANK_OFFSETS)};
           assign SPD_AP_Row_Offset   = {decode_offset(C_MEM_SUPPORTED_ROW_OFFSETS),decode_offset(C_MEM_SUPPORTED_ROW_OFFSETS)};
           assign SPD_AP_Col_Offset   = {decode_offset(C_MEM_SUPPORTED_COL_OFFSETS),decode_offset(C_MEM_SUPPORTED_COL_OFFSETS)};
        end
      else
        begin : SPD_Offsets_1_DIMMS
           assign SPD_AP_Total_Offset = decode_offset(C_MEM_SUPPORTED_TOTAL_OFFSETS);
           assign SPD_AP_DIMM_Offset  = decode_offset(C_MEM_SUPPORTED_DIMM_OFFSETS);
           assign SPD_AP_Rank_Offset  = decode_offset(C_MEM_SUPPORTED_RANK_OFFSETS);
           assign SPD_AP_Bank_Offset  = decode_offset(C_MEM_SUPPORTED_BANK_OFFSETS);
           assign SPD_AP_Row_Offset   = decode_offset(C_MEM_SUPPORTED_ROW_OFFSETS);
           assign SPD_AP_Col_Offset   = decode_offset(C_MEM_SUPPORTED_COL_OFFSETS);
        end
   endgenerate
   mpmc_addr_path #(
      .C_FAMILY(C_FAMILY),
      .C_USE_STATIC_PHY(C_USE_STATIC_PHY),
      .C_NUM_PORTS(C_NUM_PORTS),
      .C_PI_ADDR_WIDTH(C_PIX_ADDR_WIDTH_MAX),
      .C_MEM_ADDR_WIDTH(C_MEM_ADDR_WIDTH),
      .C_MEM_BANKADDR_WIDTH(C_MEM_BANKADDR_WIDTH),
      .C_MEM_DATA_WIDTH(C_MEM_DATA_WIDTH),
      .C_MEM_BURST_LENGTH(C_MEM_BURST_LENGTH),
      .C_AP_PIPELINE1(C_AP_PIPELINE1),
      .C_AP_PIPELINE2(C_AP_PIPELINE2),
      .C_MEM_NUM_DIMMS(C_MEM_NUM_DIMMS),
      .C_MEM_NUM_RANKS(C_MEM_NUM_RANKS),
      .C_MEM_SUPPORTED_TOTAL_OFFSETS(C_MEM_SUPPORTED_TOTAL_OFFSETS),
      .C_MEM_SUPPORTED_DIMM_OFFSETS(C_MEM_SUPPORTED_DIMM_OFFSETS),
      .C_MEM_SUPPORTED_RANK_OFFSETS(C_MEM_SUPPORTED_RANK_OFFSETS),
      .C_MEM_SUPPORTED_BANK_OFFSETS(C_MEM_SUPPORTED_BANK_OFFSETS),
      .C_MEM_SUPPORTED_ROW_OFFSETS(C_MEM_SUPPORTED_ROW_OFFSETS),
      .C_MEM_SUPPORTED_COL_OFFSETS(C_MEM_SUPPORTED_COL_OFFSETS),
      .C_IS_DDR(C_IS_DDR)
   )
     mpmc_addr_path_0 (
      // System Signals
      .Clk0(Clk0),                                              // I
      .Clk90(Clk90),                                            // I
      .Rst(Rst[C_NUM_PORTS*2+2]),                                                // I
      // Memory Signals (To/From Memory Pins)
      .AP_PhyIF_BankAddr(AP_PhyIF_BankAddr_i),                  // O [C_MEM_BANKADDR_WIDTH-1:0]
      .AP_PhyIF_Addr(AP_PhyIF_Addr_i),                          // O [C_MEM_ADDR_WIDTH-1:0]
      .AP_PhyIF_CS_n(AP_PhyIF_CS_n_i),                          // O [C_MEM_NUM_RANKS*C_MEM_NUM_DIMMS-1:0]
      // Port Interface Signals
      .PI_Addr(PI_Addr),                                        // I [C_PI_ADDR_WIDTH*C_NUM_PORTS-1:0]
      // EEPROM Serial Presence Detect Signals
      .SPD_AP_Total_Offset(SPD_AP_Total_Offset),                // I [8*C_MEM_NUM_DIMMS-1:0]
      .SPD_AP_DIMM_Offset(SPD_AP_DIMM_Offset),                  // I [8*C_MEM_NUM_DIMMS-1:0]
      .SPD_AP_Rank_Offset(SPD_AP_Rank_Offset),                  // I [8*C_MEM_NUM_DIMMS-1:0]
      .SPD_AP_Bank_Offset(SPD_AP_Bank_Offset),                  // I [8*C_MEM_NUM_DIMMS-1:0]
      .SPD_AP_Row_Offset(SPD_AP_Row_Offset),                    // I [8*C_MEM_NUM_DIMMS-1:0]
      .SPD_AP_Col_Offset(SPD_AP_Col_Offset),                    // I [8*C_MEM_NUM_DIMMS-1:0]
      // Address Decode for Control Path
      .AP_Ctrl_Addr(AP_Ctrl_Addr),                              // O [C_PI_ADDR_WIDTH-1:0]
      // Control Signals
      .Ctrl_AP_PI_Addr_CE(Ctrl_AP_PI_Addr_CE),                  // I [C_NUM_PORTS-1:0]
      .Ctrl_AP_Port_Select(Ctrl_AP_Port_Select),                // I [C_NUM_PORTS-1:0]
      .Ctrl_AP_Pipeline1_CE(Ctrl_AP_Pipeline1_CE),              // I
      .Ctrl_AP_Row_Col_Sel(Ctrl_AP_Row_Col_Sel),                // I
      .Ctrl_AP_Col_Cnt_Load(Ctrl_AP_Col_Cnt_Load),              // I
      .Ctrl_AP_Col_Cnt_Enable(Ctrl_AP_Col_Cnt_Enable),          // I
      .Ctrl_AP_Col_W(Ctrl_AP_Col_W),                            // I
      .Ctrl_AP_Col_DW(Ctrl_AP_Col_DW),                          // I
      .Ctrl_AP_Col_CL4(Ctrl_AP_Col_CL4),                        // I
      .Ctrl_AP_Col_CL8(Ctrl_AP_Col_CL8),                        // I
      .Ctrl_AP_Col_B16(Ctrl_AP_Col_B16),                        // I
      .Ctrl_AP_Col_B32(Ctrl_AP_Col_B32),                        // I
      .Ctrl_AP_Col_B64(Ctrl_AP_Col_B64),                        // I
      .Ctrl_AP_Precharge_Addr10(Ctrl_AP_Precharge_Addr10),      // I
      .Ctrl_AP_Assert_All_CS(Ctrl_AP_Assert_All_CS)             // I
   ); 

   // Control Path
   assign Arb_Sequence = 0;
   assign Arb_LoadSequence = 0;
   mpmc_ctrl_path 
     #(
       .C_FAMILY                     (C_FAMILY),
       .C_USE_STATIC_PHY             (C_USE_STATIC_PHY),
       .C_MEM_TYPE                   (C_MEM_TYPE),
       .C_INCLUDE_ECC_SUPPORT        (C_INCLUDE_ECC_SUPPORT),
       .C_ECC_ENCODE_PIPELINE        (C_ECC_ENCODE_PIPELINE),
       .C_MEM_DDR2_ENABLE            (C_MEM_DDR2_ENABLE),
       .C_NUM_PORTS                  (C_NUM_PORTS),
       .C_NUM_CTRL_SIGNALS           (C_NUM_CTRL_SIGNALS),
       .C_PIPELINE_ADDRACK           (C_PIPELINE_ADDRACK),
       .C_CP_PIPELINE                (C_CP_PIPELINE),
       .C_ARB_PIPELINE               (C_ARB_PIPELINE),
       .C_MAX_REQ_ALLOWED            (C_MAX_REQ_ALLOWED),
       .C_REQ_PENDING_CNTR_WIDTH     (C_REQ_PENDING_CNTR_WIDTH),
       .C_REFRESH_CNT_MAX            (C_REFRESH_CNT_MAX),
       .C_REFRESH_CNT_WIDTH          (C_REFRESH_CNT_WIDTH),
       .C_MEM_REG_DIMM               (C_MEM_REG_DIMM),
       .C_IS_DDR                     (C_IS_DDR),
       .C_MEM_DATA_WIDTH             (C_MEM_DATA_WIDTH),
       .C_MEM_DM_WIDTH               (C_MEM_DM_WIDTH),
       .C_MEM_DQS_WIDTH              (C_MEM_DQS_WIDTH),
       .C_PI_DATA_WIDTH              (C_PI_DATA_WIDTH),
       .C_WR_FIFO_MEM_PIPELINE       (C_WR_FIFO_MEM_PIPELINE_SINGLE),
       .C_PORT_FOR_WRITE_TRAINING_PATTERN  (C_WR_TRAINING_PORT),
       .C_AP_PIPELINE1                 (C_AP_PIPELINE1),
       .C_BURST_LENGTH                 (C_MEM_BURST_LENGTH),
       .C_INIT0_STALL                  (C_INIT0_STALL),
       .C_INIT1_STALL                  (C_INIT1_STALL),
       .C_INIT2_STALL                  (C_INIT2_STALL),
       .C_WORD_WRITE_SEQ               (C_WORD_WRITE_SEQ),
       .C_WORD_READ_SEQ                (C_WORD_READ_SEQ),
       .C_DOUBLEWORD_WRITE_SEQ         (C_DOUBLEWORD_WRITE_SEQ),
       .C_DOUBLEWORD_READ_SEQ          (C_DOUBLEWORD_READ_SEQ),
       .C_CL4_WRITE_SEQ                (C_CL4_WRITE_SEQ),
       .C_CL4_READ_SEQ                 (C_CL4_READ_SEQ),
       .C_CL8_WRITE_SEQ                (C_CL8_WRITE_SEQ),
       .C_CL8_READ_SEQ                 (C_CL8_READ_SEQ),
       .C_B16_WRITE_SEQ                (C_B16_WRITE_SEQ),
       .C_B16_READ_SEQ                 (C_B16_READ_SEQ),
       .C_B32_WRITE_SEQ                (C_B32_WRITE_SEQ),
       .C_B32_READ_SEQ                 (C_B32_READ_SEQ),
       .C_B64_WRITE_SEQ                (C_B64_WRITE_SEQ),
       .C_B64_READ_SEQ                 (C_B64_READ_SEQ),
       .C_NOP_SEQ                      (C_NOP_SEQ),
       .C_REFH_SEQ                     (C_REFH_SEQ),
       .C_CTRL_AP_COL_DELAY            (C_CTRL_AP_COL_DELAY),
       .C_CTRL_AP_PI_ADDR_CE_DELAY     (C_CTRL_AP_PI_ADDR_CE_DELAY),
       .C_CTRL_AP_PORT_SELECT_DELAY    (C_CTRL_AP_PORT_SELECT_DELAY),
       .C_CTRL_AP_PIPELINE1_CE_DELAY   (C_CTRL_AP_PIPELINE1_CE_DELAY),
       .C_CTRL_DP_RDFIFO_WHICHPORT_DELAY ((C_MEM_TYPE == "SDRAM") ? C_CTRL_DP_RDFIFO_WHICHPORT_DELAY-1 : C_CTRL_DP_RDFIFO_WHICHPORT_DELAY),
       .C_CTRL_DP_SIZE_DELAY           (C_CTRL_DP_SIZE_DELAY),
       .C_CTRL_DP_WRFIFO_WHICHPORT_REP (C_CTRL_DP_WRFIFO_WHICHPORT_REP),
       .C_CTRL_DP_WRFIFO_WHICHPORT_DELAY (C_CTRL_DP_WRFIFO_WHICHPORT_DELAY),
       .C_CTRL_PHYIF_DUMMYREADSTART_DELAY (C_CTRL_PHYIF_DUMMYREADSTART_DELAY),
       .C_CTRL_Q0_DELAY                (C_CTRL_Q0_DELAY),
       .C_CTRL_Q1_DELAY                (C_CTRL_Q1_DELAY),
       .C_CTRL_Q2_DELAY                (C_CTRL_Q2_DELAY),
       .C_CTRL_Q3_DELAY                (C_CTRL_Q3_DELAY),
       .C_CTRL_Q4_DELAY                (C_CTRL_Q4_DELAY),
       .C_CTRL_Q5_DELAY                (C_CTRL_Q5_DELAY),
       .C_CTRL_Q6_DELAY                (C_CTRL_Q6_DELAY),
       .C_CTRL_Q7_DELAY                (C_CTRL_Q7_DELAY),
       .C_CTRL_Q8_DELAY                (((C_FAMILY == "virtex5") && 
                                         (C_USE_STATIC_PHY == 0) && 
                                         (C_MEM_TYPE == "DDR2")) ? 
                                        C_CTRL_Q8_DELAY + 2 : 
                                        C_CTRL_Q8_DELAY),
       .C_CTRL_Q9_DELAY                (C_CTRL_Q9_DELAY),
       .C_CTRL_Q10_DELAY               (((C_FAMILY == "virtex5") && 
                                         (C_USE_STATIC_PHY == 0) && 
                                         (C_MEM_TYPE == "DDR2")) ? 
                                        C_CTRL_Q10_DELAY + 1 : 
                                        C_CTRL_Q10_DELAY),
       .C_CTRL_Q11_DELAY               (C_CTRL_Q11_DELAY),
       .C_CTRL_Q12_DELAY               (C_CTRL_Q12_DELAY),
       .C_CTRL_Q13_DELAY               (C_CTRL_Q13_DELAY),
       .C_CTRL_Q14_DELAY               (C_CTRL_Q14_DELAY),
       .C_CTRL_Q15_DELAY               (C_CTRL_Q15_DELAY),
       .C_CTRL_Q16_DELAY               (C_CTRL_Q16_DELAY),
       .C_CTRL_Q17_DELAY               (C_CTRL_Q17_DELAY),
       .C_CTRL_Q18_DELAY               (C_CTRL_Q18_DELAY),
       .C_CTRL_Q19_DELAY               (C_CTRL_Q19_DELAY),
       .C_CTRL_Q20_DELAY               (C_CTRL_Q20_DELAY),
       .C_CTRL_Q21_DELAY               (C_CTRL_Q21_DELAY),
       .C_CTRL_Q22_DELAY               (C_CTRL_Q22_DELAY),
       .C_CTRL_Q23_DELAY               (C_CTRL_Q23_DELAY),
       .C_CTRL_Q24_DELAY               (C_CTRL_Q24_DELAY),
       .C_CTRL_Q25_DELAY               (C_CTRL_Q25_DELAY),
       .C_CTRL_Q26_DELAY               (C_CTRL_Q26_DELAY),
       .C_CTRL_Q27_DELAY               (C_CTRL_Q27_DELAY),
       .C_CTRL_Q28_DELAY               (C_CTRL_Q28_DELAY),
       .C_CTRL_Q29_DELAY               (C_CTRL_Q29_DELAY),
       .C_CTRL_Q30_DELAY               (C_CTRL_Q30_DELAY),
       .C_CTRL_Q31_DELAY               (C_CTRL_Q31_DELAY),
       .C_CTRL_Q32_DELAY               (C_CTRL_Q32_DELAY),
       .C_CTRL_Q33_DELAY               (C_CTRL_Q33_DELAY),
       .C_CTRL_Q34_DELAY               (C_CTRL_Q34_DELAY),
       .C_CTRL_Q35_DELAY               (C_CTRL_Q35_DELAY),
       .C_ARB0_ALGO                    (C_ARB0_ALGO),
       .C_BASEADDR_ARB0                (C_BASEADDR_ARB0),
       .C_HIGHADDR_ARB0                (C_HIGHADDR_ARB0),
       .C_BASEADDR_ARB1                (C_BASEADDR_ARB1),
       .C_HIGHADDR_ARB1                (C_HIGHADDR_ARB1),
       .C_BASEADDR_ARB2                (C_BASEADDR_ARB2),
       .C_HIGHADDR_ARB2                (C_HIGHADDR_ARB2),
       .C_BASEADDR_ARB3                (C_BASEADDR_ARB3),
       .C_HIGHADDR_ARB3                (C_HIGHADDR_ARB3),
       .C_BASEADDR_ARB4                (C_BASEADDR_ARB4),
       .C_HIGHADDR_ARB4                (C_HIGHADDR_ARB4),
       .C_BASEADDR_ARB5                (C_BASEADDR_ARB5),
       .C_HIGHADDR_ARB5                (C_HIGHADDR_ARB5),
       .C_BASEADDR_ARB6                (C_BASEADDR_ARB6),
       .C_HIGHADDR_ARB6                (C_HIGHADDR_ARB6),
       .C_BASEADDR_ARB7                (C_BASEADDR_ARB7),
       .C_HIGHADDR_ARB7                (C_HIGHADDR_ARB7),
       .C_BASEADDR_ARB8                (C_BASEADDR_ARB8),
       .C_HIGHADDR_ARB8                (C_HIGHADDR_ARB8),
       .C_BASEADDR_ARB9                (C_BASEADDR_ARB9),
       .C_HIGHADDR_ARB9                (C_HIGHADDR_ARB9),
       .C_BASEADDR_ARB10               (C_BASEADDR_ARB10),
       .C_HIGHADDR_ARB10               (C_HIGHADDR_ARB10),
       .C_BASEADDR_ARB11               (C_BASEADDR_ARB11),
       .C_HIGHADDR_ARB11               (C_HIGHADDR_ARB11),
       .C_BASEADDR_ARB12               (C_BASEADDR_ARB12),
       .C_HIGHADDR_ARB12               (C_HIGHADDR_ARB12),
       .C_BASEADDR_ARB13               (C_BASEADDR_ARB13),
       .C_HIGHADDR_ARB13               (C_HIGHADDR_ARB13),
       .C_BASEADDR_ARB14               (C_BASEADDR_ARB14),
       .C_HIGHADDR_ARB14               (C_HIGHADDR_ARB14),
       .C_BASEADDR_ARB15               (C_BASEADDR_ARB15),
       .C_HIGHADDR_ARB15               (C_HIGHADDR_ARB15),
       .C_ARB_BRAM_SRVAL_A             (C_ARB_BRAM_SRVAL_A),
       .C_ARB_BRAM_SRVAL_B             (C_ARB_BRAM_SRVAL_B),
       .C_ARB_BRAM_INIT_00             (C_ARB_BRAM_INIT_00),
       .C_ARB_BRAM_INIT_01             (C_ARB_BRAM_INIT_01),
       .C_ARB_BRAM_INIT_02             (C_ARB_BRAM_INIT_02),
       .C_ARB_BRAM_INIT_03             (C_ARB_BRAM_INIT_03),
       .C_ARB_BRAM_INIT_04             (C_ARB_BRAM_INIT_04),
       .C_ARB_BRAM_INIT_05             (C_ARB_BRAM_INIT_05),
       .C_ARB_BRAM_INIT_06             (C_ARB_BRAM_INIT_06),
       .C_ARB_BRAM_INIT_07             (C_ARB_BRAM_INIT_07),
       .C_ARB_BRAM_INIT_08             (C_ARB_BRAM_INIT_08),
       .C_ARB_BRAM_INIT_09             (C_ARB_BRAM_INIT_09),
       .C_ARB_BRAM_INIT_0A             (C_ARB_BRAM_INIT_0A),
       .C_ARB_BRAM_INIT_0B             (C_ARB_BRAM_INIT_0B),
       .C_ARB_BRAM_INIT_0C             (C_ARB_BRAM_INIT_0C),
       .C_ARB_BRAM_INIT_0D             (C_ARB_BRAM_INIT_0D),
       .C_ARB_BRAM_INIT_0E             (C_ARB_BRAM_INIT_0E),
       .C_ARB_BRAM_INIT_0F             (C_ARB_BRAM_INIT_0F),
       .C_ARB_BRAM_INIT_10             (C_ARB_BRAM_INIT_10),
       .C_ARB_BRAM_INIT_11             (C_ARB_BRAM_INIT_11),
       .C_ARB_BRAM_INIT_12             (C_ARB_BRAM_INIT_12),
       .C_ARB_BRAM_INIT_13             (C_ARB_BRAM_INIT_13),
       .C_ARB_BRAM_INIT_14             (C_ARB_BRAM_INIT_14),
       .C_ARB_BRAM_INIT_15             (C_ARB_BRAM_INIT_15),
       .C_ARB_BRAM_INIT_16             (C_ARB_BRAM_INIT_16),
       .C_ARB_BRAM_INIT_17             (C_ARB_BRAM_INIT_17),
       .C_ARB_BRAM_INIT_18             (C_ARB_BRAM_INIT_18),
       .C_ARB_BRAM_INIT_19             (C_ARB_BRAM_INIT_19),
       .C_ARB_BRAM_INIT_1A             (C_ARB_BRAM_INIT_1A),
       .C_ARB_BRAM_INIT_1B             (C_ARB_BRAM_INIT_1B),
       .C_ARB_BRAM_INIT_1C             (C_ARB_BRAM_INIT_1C),
       .C_ARB_BRAM_INIT_1D             (C_ARB_BRAM_INIT_1D),
       .C_ARB_BRAM_INIT_1E             (C_ARB_BRAM_INIT_1E),
       .C_ARB_BRAM_INIT_1F             (C_ARB_BRAM_INIT_1F),
       .C_ARB_BRAM_INIT_20             (C_ARB_BRAM_INIT_20),
       .C_ARB_BRAM_INIT_21             (C_ARB_BRAM_INIT_21),
       .C_ARB_BRAM_INIT_22             (C_ARB_BRAM_INIT_22),
       .C_ARB_BRAM_INIT_23             (C_ARB_BRAM_INIT_23),
       .C_ARB_BRAM_INIT_24             (C_ARB_BRAM_INIT_24),
       .C_ARB_BRAM_INIT_25             (C_ARB_BRAM_INIT_25),
       .C_ARB_BRAM_INIT_26             (C_ARB_BRAM_INIT_26),
       .C_ARB_BRAM_INIT_27             (C_ARB_BRAM_INIT_27),
       .C_ARB_BRAM_INIT_28             (C_ARB_BRAM_INIT_28),
       .C_ARB_BRAM_INIT_29             (C_ARB_BRAM_INIT_29),
       .C_ARB_BRAM_INIT_2A             (C_ARB_BRAM_INIT_2A),
       .C_ARB_BRAM_INIT_2B             (C_ARB_BRAM_INIT_2B),
       .C_ARB_BRAM_INIT_2C             (C_ARB_BRAM_INIT_2C),
       .C_ARB_BRAM_INIT_2D             (C_ARB_BRAM_INIT_2D),
       .C_ARB_BRAM_INIT_2E             (C_ARB_BRAM_INIT_2E),
       .C_ARB_BRAM_INIT_2F             (C_ARB_BRAM_INIT_2F),
       .C_ARB_BRAM_INIT_30             (C_ARB_BRAM_INIT_30),
       .C_ARB_BRAM_INIT_31             (C_ARB_BRAM_INIT_31),
       .C_ARB_BRAM_INIT_32             (C_ARB_BRAM_INIT_32),
       .C_ARB_BRAM_INIT_33             (C_ARB_BRAM_INIT_33),
       .C_ARB_BRAM_INIT_34             (C_ARB_BRAM_INIT_34),
       .C_ARB_BRAM_INIT_35             (C_ARB_BRAM_INIT_35),
       .C_ARB_BRAM_INIT_36             (C_ARB_BRAM_INIT_36),
       .C_ARB_BRAM_INIT_37             (C_ARB_BRAM_INIT_37),
       .C_ARB_BRAM_INIT_38             (C_ARB_BRAM_INIT_38),
       .C_ARB_BRAM_INIT_39             (C_ARB_BRAM_INIT_39),
       .C_ARB_BRAM_INIT_3A             (C_ARB_BRAM_INIT_3A),
       .C_ARB_BRAM_INIT_3B             (C_ARB_BRAM_INIT_3B),
       .C_ARB_BRAM_INIT_3C             (C_ARB_BRAM_INIT_3C),
       .C_ARB_BRAM_INIT_3D             (C_ARB_BRAM_INIT_3D),
       .C_ARB_BRAM_INIT_3E             (C_ARB_BRAM_INIT_3E),
       .C_ARB_BRAM_INIT_3F             (C_ARB_BRAM_INIT_3F),
       .C_ARB_BRAM_INITP_00            (C_ARB_BRAM_INITP_00),
       .C_ARB_BRAM_INITP_01            (C_ARB_BRAM_INITP_01),
       .C_ARB_BRAM_INITP_02            (C_ARB_BRAM_INITP_02),
       .C_ARB_BRAM_INITP_03            (C_ARB_BRAM_INITP_03),
       .C_ARB_BRAM_INITP_04            (C_ARB_BRAM_INITP_04),
       .C_ARB_BRAM_INITP_05            (C_ARB_BRAM_INITP_05),
       .C_ARB_BRAM_INITP_06            (C_ARB_BRAM_INITP_06),
       .C_ARB_BRAM_INITP_07            (C_ARB_BRAM_INITP_07),
       .C_USE_FIXED_BASEADDR_CTRL      (C_USE_FIXED_BASEADDR_CTRL),
       .C_B16_REPEAT_CNT               (C_B16_REPEAT_CNT),
       .C_B32_REPEAT_CNT               (C_B32_REPEAT_CNT),
       .C_B64_REPEAT_CNT               (C_B64_REPEAT_CNT),
       .C_BASEADDR_CTRL0               (C_BASEADDR_CTRL0),
       .C_HIGHADDR_CTRL0               (C_HIGHADDR_CTRL0),
       .C_BASEADDR_CTRL1               (C_BASEADDR_CTRL1),
       .C_HIGHADDR_CTRL1               (C_HIGHADDR_CTRL1),
       .C_BASEADDR_CTRL2               (C_BASEADDR_CTRL2),
       .C_HIGHADDR_CTRL2               (C_HIGHADDR_CTRL2),
       .C_BASEADDR_CTRL3               (C_BASEADDR_CTRL3),
       .C_HIGHADDR_CTRL3               (C_HIGHADDR_CTRL3),
       .C_BASEADDR_CTRL4               (C_BASEADDR_CTRL4),
       .C_HIGHADDR_CTRL4               (C_HIGHADDR_CTRL4),
       .C_BASEADDR_CTRL5               (C_BASEADDR_CTRL5),
       .C_HIGHADDR_CTRL5               (C_HIGHADDR_CTRL5),
       .C_BASEADDR_CTRL6               (C_BASEADDR_CTRL6),
       .C_HIGHADDR_CTRL6               (C_HIGHADDR_CTRL6),
       .C_BASEADDR_CTRL7               (C_BASEADDR_CTRL7),
       .C_HIGHADDR_CTRL7               (C_HIGHADDR_CTRL7),
       .C_BASEADDR_CTRL8               (C_BASEADDR_CTRL8),
       .C_HIGHADDR_CTRL8               (C_HIGHADDR_CTRL8),
       .C_BASEADDR_CTRL9               (C_BASEADDR_CTRL9),
       .C_HIGHADDR_CTRL9               (C_HIGHADDR_CTRL9),
       .C_BASEADDR_CTRL10              (C_BASEADDR_CTRL10),
       .C_HIGHADDR_CTRL10              (C_HIGHADDR_CTRL10),
       .C_BASEADDR_CTRL11              (C_BASEADDR_CTRL11),
       .C_HIGHADDR_CTRL11              (C_HIGHADDR_CTRL11),
       .C_BASEADDR_CTRL12              (C_BASEADDR_CTRL12),
       .C_HIGHADDR_CTRL12              (C_HIGHADDR_CTRL12),
       .C_BASEADDR_CTRL13              (C_BASEADDR_CTRL13),
       .C_HIGHADDR_CTRL13              (C_HIGHADDR_CTRL13),
       .C_BASEADDR_CTRL14              (C_BASEADDR_CTRL14),
       .C_HIGHADDR_CTRL14              (C_HIGHADDR_CTRL14),
       .C_BASEADDR_CTRL15              (C_BASEADDR_CTRL15),
       .C_HIGHADDR_CTRL15              (C_HIGHADDR_CTRL15),
       .C_CTRL_BRAM_SRVAL            (C_CTRL_BRAM_SRVAL),
       .C_CTRL_BRAM_INIT_00          (C_CTRL_BRAM_INIT_00),
       .C_CTRL_BRAM_INIT_01          (C_CTRL_BRAM_INIT_01),
       .C_CTRL_BRAM_INIT_02          (C_CTRL_BRAM_INIT_02),
       .C_CTRL_BRAM_INIT_03          (C_CTRL_BRAM_INIT_03),
       .C_CTRL_BRAM_INIT_04          (C_CTRL_BRAM_INIT_04),
       .C_CTRL_BRAM_INIT_05          (C_CTRL_BRAM_INIT_05),
       .C_CTRL_BRAM_INIT_06          (C_CTRL_BRAM_INIT_06),
       .C_CTRL_BRAM_INIT_07          (C_CTRL_BRAM_INIT_07),
       .C_CTRL_BRAM_INIT_08          (C_CTRL_BRAM_INIT_08),
       .C_CTRL_BRAM_INIT_09          (C_CTRL_BRAM_INIT_09),
       .C_CTRL_BRAM_INIT_0A          (C_CTRL_BRAM_INIT_0A),
       .C_CTRL_BRAM_INIT_0B          (C_CTRL_BRAM_INIT_0B),
       .C_CTRL_BRAM_INIT_0C          (C_CTRL_BRAM_INIT_0C),
       .C_CTRL_BRAM_INIT_0D          (C_CTRL_BRAM_INIT_0D),
       .C_CTRL_BRAM_INIT_0E          (C_CTRL_BRAM_INIT_0E),
       .C_CTRL_BRAM_INIT_0F          (C_CTRL_BRAM_INIT_0F),
       .C_CTRL_BRAM_INIT_10          (C_CTRL_BRAM_INIT_10),
       .C_CTRL_BRAM_INIT_11          (C_CTRL_BRAM_INIT_11),
       .C_CTRL_BRAM_INIT_12          (C_CTRL_BRAM_INIT_12),
       .C_CTRL_BRAM_INIT_13          (C_CTRL_BRAM_INIT_13),
       .C_CTRL_BRAM_INIT_14          (C_CTRL_BRAM_INIT_14),
       .C_CTRL_BRAM_INIT_15          (C_CTRL_BRAM_INIT_15),
       .C_CTRL_BRAM_INIT_16          (C_CTRL_BRAM_INIT_16),
       .C_CTRL_BRAM_INIT_17          (C_CTRL_BRAM_INIT_17),
       .C_CTRL_BRAM_INIT_18          (C_CTRL_BRAM_INIT_18),
       .C_CTRL_BRAM_INIT_19          (C_CTRL_BRAM_INIT_19),
       .C_CTRL_BRAM_INIT_1A          (C_CTRL_BRAM_INIT_1A),
       .C_CTRL_BRAM_INIT_1B          (C_CTRL_BRAM_INIT_1B),
       .C_CTRL_BRAM_INIT_1C          (C_CTRL_BRAM_INIT_1C),
       .C_CTRL_BRAM_INIT_1D          (C_CTRL_BRAM_INIT_1D),
       .C_CTRL_BRAM_INIT_1E          (C_CTRL_BRAM_INIT_1E),
       .C_CTRL_BRAM_INIT_1F          (C_CTRL_BRAM_INIT_1F),
       .C_CTRL_BRAM_INIT_20          (C_CTRL_BRAM_INIT_20),
       .C_CTRL_BRAM_INIT_21          (C_CTRL_BRAM_INIT_21),
       .C_CTRL_BRAM_INIT_22          (C_CTRL_BRAM_INIT_22),
       .C_CTRL_BRAM_INIT_23          (C_CTRL_BRAM_INIT_23),
       .C_CTRL_BRAM_INIT_24          (C_CTRL_BRAM_INIT_24),
       .C_CTRL_BRAM_INIT_25          (C_CTRL_BRAM_INIT_25),
       .C_CTRL_BRAM_INIT_26          (C_CTRL_BRAM_INIT_26),
       .C_CTRL_BRAM_INIT_27          (C_CTRL_BRAM_INIT_27),
       .C_CTRL_BRAM_INIT_28          (C_CTRL_BRAM_INIT_28),
       .C_CTRL_BRAM_INIT_29          (C_CTRL_BRAM_INIT_29),
       .C_CTRL_BRAM_INIT_2A          (C_CTRL_BRAM_INIT_2A),
       .C_CTRL_BRAM_INIT_2B          (C_CTRL_BRAM_INIT_2B),
       .C_CTRL_BRAM_INIT_2C          (C_CTRL_BRAM_INIT_2C),
       .C_CTRL_BRAM_INIT_2D          (C_CTRL_BRAM_INIT_2D),
       .C_CTRL_BRAM_INIT_2E          (C_CTRL_BRAM_INIT_2E),
       .C_CTRL_BRAM_INIT_2F          (C_CTRL_BRAM_INIT_2F),
       .C_CTRL_BRAM_INIT_30          (C_CTRL_BRAM_INIT_30),
       .C_CTRL_BRAM_INIT_31          (C_CTRL_BRAM_INIT_31),
       .C_CTRL_BRAM_INIT_32          (C_CTRL_BRAM_INIT_32),
       .C_CTRL_BRAM_INIT_33          (C_CTRL_BRAM_INIT_33),
       .C_CTRL_BRAM_INIT_34          (C_CTRL_BRAM_INIT_34),
       .C_CTRL_BRAM_INIT_35          (C_CTRL_BRAM_INIT_35),
       .C_CTRL_BRAM_INIT_36          (C_CTRL_BRAM_INIT_36),
       .C_CTRL_BRAM_INIT_37          (C_CTRL_BRAM_INIT_37),
       .C_CTRL_BRAM_INIT_38          (C_CTRL_BRAM_INIT_38),
       .C_CTRL_BRAM_INIT_39          (C_CTRL_BRAM_INIT_39),
       .C_CTRL_BRAM_INIT_3A          (C_CTRL_BRAM_INIT_3A),
       .C_CTRL_BRAM_INIT_3B          (C_CTRL_BRAM_INIT_3B),
       .C_CTRL_BRAM_INIT_3C          (C_CTRL_BRAM_INIT_3C),
       .C_CTRL_BRAM_INIT_3D          (C_CTRL_BRAM_INIT_3D),
       .C_CTRL_BRAM_INIT_3E          (C_CTRL_BRAM_INIT_3E),
       .C_CTRL_BRAM_INIT_3F          (C_CTRL_BRAM_INIT_3F),
       .C_CTRL_BRAM_INITP_00         (C_CTRL_BRAM_INITP_00),
       .C_CTRL_BRAM_INITP_01         (C_CTRL_BRAM_INITP_01),
       .C_CTRL_BRAM_INITP_02         (C_CTRL_BRAM_INITP_02),
       .C_CTRL_BRAM_INITP_03         (C_CTRL_BRAM_INITP_03),
       .C_CTRL_BRAM_INITP_04         (C_CTRL_BRAM_INITP_04),
       .C_CTRL_BRAM_INITP_05         (C_CTRL_BRAM_INITP_05),
       .C_CTRL_BRAM_INITP_06         (C_CTRL_BRAM_INITP_06),
       .C_CTRL_BRAM_INITP_07         (C_CTRL_BRAM_INITP_07),
       .C_SKIP_1_VALUE               (C_SKIP_1_VALUE),
       .C_SKIP_2_VALUE               (C_SKIP_2_VALUE),
       .C_SKIP_3_VALUE               (C_SKIP_3_VALUE),
       .C_SKIP_4_VALUE               (C_SKIP_4_VALUE),
       .C_SKIP_5_VALUE               (C_SKIP_5_VALUE),
       .C_SKIP_6_VALUE               (C_SKIP_6_VALUE),
       .C_SKIP_7_VALUE               (C_SKIP_7_VALUE)
   )
     mpmc_ctrl_path_0 
       (
        .Clk                       (Clk0),
        .Clk90                     (Clk90),
        .Rst                       (Rst[C_NUM_PORTS*2+3]),
        .PI_AddrReq                (PI_AddrReq),
        .PI_Size                   (PI_Size),
        .PI_RNW                    (PI_RNW),
        .PI_RdModWr                (PI_RdModWr),
        .PI_AddrAck                (PI_AddrAck),
        .AP_Ctrl_Addr              (AP_Ctrl_Addr),                // I [31:0]
        .Ctrl_ECC_RdFIFO_Size      (Ctrl_ECC_RdFIFO_Size_i),      // O [3:0]
        .Ctrl_ECC_RdFIFO_RNW       (Ctrl_ECC_RdFIFO_RNW_i),       // O
        .Ctrl_ECC_RdFIFO_Addr      (Ctrl_ECC_RdFIFO_Addr),        // O [31:0]
        .Ctrl_AP_Col_W             (Ctrl_AP_Col_W),               // O
        .Ctrl_AP_Col_DW            (Ctrl_AP_Col_DW),              // O
        .Ctrl_AP_Col_CL4           (Ctrl_AP_Col_CL4),             // O
        .Ctrl_AP_Col_CL8           (Ctrl_AP_Col_CL8),             // O
        .Ctrl_AP_Col_B16           (Ctrl_AP_Col_B16),             // O
        .Ctrl_AP_Col_B32           (Ctrl_AP_Col_B32),             // O
        .Ctrl_AP_Col_B64           (Ctrl_AP_Col_B64),             // O
        .Ctrl_AP_PI_Addr_CE        (Ctrl_AP_PI_Addr_CE),          // O [C_NUM_PORTS-1:0]
        .Ctrl_AP_Port_Select       (Ctrl_AP_Port_Select),         // O [C_ARB_PORT_ENCODING_WIDTH-1:0]
        .Ctrl_AP_Col_Cnt_Load      (Ctrl_AP_Col_Cnt_Load),        // O
        .Ctrl_AP_Col_Cnt_Enable    (Ctrl_AP_Col_Cnt_Enable),      // O
        .Ctrl_AP_Precharge_Addr10  (Ctrl_AP_Precharge_Addr10),    // O
        .Ctrl_AP_Row_Col_Sel       (Ctrl_AP_Row_Col_Sel),         // O
        .Ctrl_AP_Pipeline1_CE      (Ctrl_AP_Pipeline1_CE),        // O
        .Ctrl_AP_Assert_All_CS     (Ctrl_AP_Assert_All_CS),       // O
        .DP_Ctrl_RdFIFO_AlmostFull (DP_Ctrl_RdFIFO_AlmostFull),   // I [C_NUM_PORTS-1:0]
        .DP_Ctrl_WrFIFO_Empty      (DP_Ctrl_WrFIFO_Empty),        // I [C_NUM_PORTS-1:0]
        .Ctrl_DP_RdFIFO_WhichPort_Decode  (Ctrl_DP_RdFIFO_WhichPort_Decode),    // O [C_ARB_PORT_ENCODING_WIDTH-1:0]
        .Ctrl_DP_Size              (Ctrl_DP_Size),                // O [3:0]
        .Ctrl_DP_WrFIFO_WhichPort  (Ctrl_DP_WrFIFO_WhichPort),    // O [C_ARB_PORT_ENCODING_WIDTH-1:0]
        .Ctrl_DP_WrFIFO_WhichPort_Decode (Ctrl_DP_WrFIFO_WhichPort_Decode), // O [C_NUM_PORTS-1:0]
        .Ctrl_DP_RdFIFO_Push       (Ctrl_DP_RdFIFO_Push),    // O
        .PhyIF_Ctrl_InitDone       (PhyIF_Ctrl_InitDone[18]),// I
        .Ctrl_PhyIF_RAS_n          (Ctrl_PhyIF_RAS_n_i),          // O
        .Ctrl_PhyIF_CAS_n          (Ctrl_PhyIF_CAS_n_i),          // O
        .Ctrl_PhyIF_WE_n           (Ctrl_PhyIF_WE_n_i),           // O
        .Ctrl_PhyIF_CE             (Ctrl_PhyIF_CE_i),             // O
        .Ctrl_Is_Write             (Ctrl_Is_Write),               // O
        .Ctrl_RMW                  (Ctrl_RMW),                    // O
        .Ctrl_PhyIF_DQS_O          (Ctrl_PhyIF_DQS_O),            // O
        .Ctrl_PhyIF_Force_DM       (Ctrl_PhyIF_Force_DM),         // O
        .Ctrl_Refresh_Flag         (Ctrl_Refresh_Flag),           // O
        .Arb_Sequence              (Arb_Sequence),
        .Arb_LoadSequence          (Arb_LoadSequence)
        );

   generate
      if (P_DELAY_PHYIF_DP_WRFIFO_POP == 1) begin : gen_reg_PhyIF_DP_WrFIFO_Pop
         always @(posedge Clk0) begin
            PhyIF_DP_WrFIFO_Pop_i    <= PhyIF_DP_WrFIFO_Pop;
            Ctrl_PhyIF_Force_DM_d1_i <= Ctrl_PhyIF_Force_DM_d1;
         end
      end
      else begin : gen_noreg_PhyIF_DP_WrFIFO_Pop
         always @(*) begin
            PhyIF_DP_WrFIFO_Pop_i    <= PhyIF_DP_WrFIFO_Pop;
            Ctrl_PhyIF_Force_DM_d1_i <= Ctrl_PhyIF_Force_DM_d1;
         end
      end
   endgenerate
   
   always @(posedge Clk0)
     Ctrl_PhyIF_Force_DM_d1 <= {C_NUM_PORTS{Ctrl_PhyIF_Force_DM[0]}};

   wire [C_NUM_PORTS-1:0] PhyIF_Ctrl_InitDone_DP;
   generate
      if ((C_FAMILY == "spartan3") || (C_FAMILY == "spartan3a") || (C_FAMILY == "spartan3e") || (C_USE_STATIC_PHY==1) || (C_IS_DDR==0)) begin : gen_phyif_ctrl_initdone_dp_spartan
         assign PhyIF_Ctrl_InitDone_DP = {C_NUM_PORTS{1'b1}};
      end
      else begin  : gen_phyif_ctrl_initdone_dp_nonspartan
         assign PhyIF_Ctrl_InitDone_DP = PhyIF_Ctrl_InitDone[C_NUM_PORTS+9:10];
      end
   endgenerate
   // SPECIAL CASE: See data_path.v
   // IF TML Pipeline enabled, and ECC enabled, cannot assert pop
   // early enough, so eliminate TML Pipeline inside of data path code.
   // mpmc_core will need to assume that TML Pipeline is set when calculating
   // when to pop data.
   generate 
      if (((C_FAMILY == "spartan3") || (C_FAMILY == "spartan3a") || (C_FAMILY == "spartan3e")) && (C_USE_STATIC_PHY == 0) && (C_IS_DDR==1) && (C_INCLUDE_ECC_SUPPORT == 0)) begin : gen_clk_wrfifo_tml_s3
         assign Clk_WrFIFO_TML = ~Clk90;
      end
      else begin : gen_clk_wrfifo_tml
         assign Clk_WrFIFO_TML = ~Clk0;
      end
   endgenerate
   mpmc_data_path #
     (
      .C_FAMILY              (C_FAMILY),
      .C_USE_INIT_PUSH       ((((C_FAMILY=="virtex5")&&(C_MEM_TYPE=="DDR2")) ||
                               (C_FAMILY=="spartan3") ||
                               (C_FAMILY=="spartan3a") ||
                               (C_FAMILY=="spartan3e") ||
                               (C_USE_STATIC_PHY==1)) ? 1'b0 : 1'b1),
      .C_PI_WRFIFO_TYPE      (C_PI_WR_FIFO_TYPE),
      .C_WRFIFO_TML_PIPELINE (C_WR_DATAPATH_TML_PIPELINE),
      .C_WRFIFO_PI_PIPELINE  (C_WR_FIFO_APP_PIPELINE),
      .C_WRFIFO_MEM_PIPELINE (C_WR_FIFO_MEM_PIPELINE),
      .C_PI_RDFIFO_TYPE      (C_PI_RD_FIFO_TYPE),
      .C_RDFIFO_MAX_FANOUT   (C_RD_DATAPATH_TML_MAX_FANOUT),
      .C_RDFIFO_PI_PIPELINE  (C_RD_FIFO_APP_PIPELINE),
      .C_RDFIFO_MEM_PIPELINE (C_RD_FIFO_MEM_PIPELINE),
      .C_NUM_PORTS           (C_NUM_PORTS),
      .C_IS_DDR              (C_IS_DDR),
      .C_MEM_DATA_WIDTH      (C_MEM_DATA_WIDTH_INT),
      .C_PI_ADDR_WIDTH       (C_PIX_ADDR_WIDTH_MAX),
      .C_PI_DATA_WIDTH       (C_PI_DATA_WIDTH),
      .C_PIX_DATA_WIDTH_MAX  (C_PIX_DATA_WIDTH_MAX),
      .C_INCLUDE_ECC_SUPPORT (C_INCLUDE_ECC_SUPPORT),
      .C_CTRL_DP_WRFIFO_WHICHPORT_REP    (C_CTRL_DP_WRFIFO_WHICHPORT_REP),
      .C_PORT_FOR_WRITE_TRAINING_PATTERN (C_WR_TRAINING_PORT)
      )
     mpmc_data_path_0
       (
        .Clk                             (Clk0),
        .Clk_WrFIFO_TML                  (Clk_WrFIFO_TML),
        .Rst                             (Rst[C_NUM_PORTS*2-1:0]),
        .PI_AddrAck                      (PI_AddrAck),
        .PI_RNW                          (PI_RNW),
        .PI_Size                         (PI_Size),
        .PI_Addr                         (PI_Addr),
        .PI_RdFIFO_Flush                 (PI_RdFIFO_Flush),
        .Ctrl_DP_RdFIFO_Push             (PhyIF_DP_RdFIFO_Push),
        .Ctrl_DP_RdFIFO_WhichPort_Decode (Ctrl_DP_RdFIFO_WhichPort_Decode_i),
        .PI_RdFIFO_Pop                   (PI_RdFIFO_Pop),
        .PI_RdFIFO_Empty                 (PI_RdFIFO_Empty),
        .DP_Ctrl_RdFIFO_AlmostFull       (DP_Ctrl_RdFIFO_AlmostFull),
        .PhyIF_DP_DQ_I                   (PhyIF_DP_DQ_I),
        .PI_RdFIFO_Data                  (PI_RdFIFO_Data),
        .PI_RdFIFO_RdWdAddr              (PI_RdFIFO_RdWdAddr),
        .InitPush                        (PhyIF_Init_Push),
        .InitData                        (PhyIF_Init_Data),
        .PI_WrFIFO_Flush                 (PI_WrFIFO_Flush),
        .PI_WrFIFO_Push                  (PI_WrFIFO_Push),
        .Ctrl_PhyIF_Force_DM             (Ctrl_PhyIF_Force_DM_d1_i),
        .Ctrl_DP_WrFIFO_Pop              (PhyIF_DP_WrFIFO_Pop_i),
        .Ctrl_DP_WrFIFO_WhichPort        (Ctrl_DP_WrFIFO_WhichPort),
        .Ctrl_DP_WrFIFO_WhichPort_Decode (Ctrl_DP_WrFIFO_WhichPort_Decode),
        .PhyIF_Ctrl_InitDone             (PhyIF_Ctrl_InitDone_DP),
        .DP_Ctrl_WrFIFO_Empty            (DP_Ctrl_WrFIFO_Empty),
        .PI_WrFIFO_AlmostFull            (PI_WrFIFO_AlmostFull),
        .PI_WrFIFO_Data                  (PI_WrFIFO_Data),
        .PI_WrFIFO_BE                    (PI_WrFIFO_BE),
        .DP_PhyIF_DQ_O                   (DP_PhyIF_DQ_O),
        .DP_PhyIF_BE_O                   (DP_PhyIF_BE_O)
        );
   
   
endmodule // mpmc_core

`default_nettype wire
